The CMake Build.
================

CMake is a cross-platform make and can be found here:

    http://www.cmake.org/

To build using CMake you'll need cmake version 2.6.0, or higher.  The
current CMakeLists.txt doesn't allow in-source builds.  This means you
have to create a build directory, but this has the advantage that the
tree can simultaneously support different operating systems and/or
different build configurations without polluting the source tree.

To get started, change directory to the root of the phoenix tree and:

UNIX (Linux/Solaris/Mac):
-------------------------

    $ mkdir unix-build
    $ cd unix-build
    $ cmake ..
    $ make [help] [VERBOSE=1]

Windows/NMake:
--------------

    $ mkdir windows-nmake-build
    $ cd windows-nmake-build
    $ cmake -G "NMake Makefiles" ..
    $ nmake [help] [VERBOSE=1]

Windows/Dev Studio:
-------------------

    $ mkdir devstudio-build
    $ cd devstudio-build
    $ cmake -G "Visual Studio 9 2008" ..
    $ PHOENIX.sln

    This will open dev studio and you can build from there.

Xcode:
------

    $ mkdir xcode-build
    $ cd xcode-build
    $ cmake -G "Xcode" ..
    $ open PHOENIX.xcodeproj

    This will open Xcode and you can build from there.

Eclipse/CDT:
------------

    $ mkdir eclipse-build
    $ cd eclipse-build
    $ cmake -G "Eclipse CDT4 - MinGW Makefiles" ..

  or:
    $ cmake -G "Eclipse CDT4 - NMake Makefiles" ..

  or:
    $ cmake -G "Eclipse CDT4 - Unix Makefiles" ..

  And import the project with Eclipse/CDT.

Note: if you're simultaneously building on different distributions of
linux you'll /probably/ need a separate build directory for each.

Debug/Release Builds
====================

By default the current CMakeLists.txt defaults to a "Release" build.
If you want a "Debug" build then:

    $ mkdir unix-debug-build
    $ cd unix-debug-build
    $ cmake -DCMAKE_BUILD_TYPE=Debug ..
    $ make [help]

You can also cross-compile on linux (using mingw32) for windows.  See
the files cmake/cross-compile.howto for details.
