/* tcf_cafe_init.c - initializes a cafe in a TCF executable exposing the Cafe config service */

/* Copyright (c) 2011 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
 */
#include <stdio.h>
#include <cafe/cafe.h>
#include <cafe/ep/config_service.h>
#include <tcf/config.h>
#include <tcf/framework/protocol.h>


int tcf_cafe_init(Protocol *proto, TCFBroadcastGroup *bcg);
int tcf_cafe_init(Protocol *proto, TCFBroadcastGroup *bcg)
{
	int rc = cafe_lib_init();
	if (rc != CAFE_OK) {
		printf("Error initializing Cafe lib: %s\n",
		       cafe_strerror(rc));
		return 0;
	}

	register_common_EPs();
	ini_cafe_config_service(proto);
	return 0;
}
