/* tcf_valueadd.c - configures the core services of the Cafe TCF valueadd */

/* Copyright (c) 2010-2011 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
 */
#include <stdio.h>
#include <cafe/cafe.h>
#include <cafe/ep/config_service.h>
#include <services/discovery.h>
#include <services/streamsservice.h>


#define QUOTEME_(x) #x
#define QUOTEME(x) QUOTEME_(x)

#define CAFE_VERSION_STRING			\
	QUOTEME(CAFE_MAJOR_VER_NUMBER) "."	\
	QUOTEME(CAFE_MINOR_VER_NUMBER) "."	\
	QUOTEME(CAFE_MICRO_VER_NUMBER)


const char buildString[] = "Cafe-valueadd-" CAFE_VERSION_STRING;


int ini_services(Protocol *proto, TCFBroadcastGroup *bcg);


int ini_services(Protocol *proto, TCFBroadcastGroup *bcg)
{
	int rc = cafe_lib_init();
	if (rc != CAFE_OK) {
		printf("Error initializing Cafe lib: %s\n",
		       cafe_strerror(rc));
		return 0;
	}

	register_common_EPs();

	ini_locator_service(proto, bcg);
	ini_streams_service(proto);
	ini_cafe_config_service(proto);
	return 0;
}
