/* Copyright (c) 2010-2011 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

#include <cafe/types.h>
#include <cafe/cafe_print.h>
#include <cafe/value_type.h>
#include <test/cafe_CUnitTest.h>
#include <cafe/ep/print.h>
#include <cafe/utils.h>
#include <cafe/ep/procfs_cfg.h>
#include <cafe/ep/ostimer.h>
#include <unistd.h>

static
int test_procfs(void)
{
	//static const int print_flags = CAFE_CFG_PRINT_INPUT | CAFE_CFG_PRINT_OUTPUT;
	struct cafe_instrument *session;
	struct cafe_ep_spec *spec;
	struct cafe_ep_inst *inst[3];

	struct cafe_cfg_setting settings[1];

	//td: these should be part of global suite setup.
	CUT_ASSERT_CAFE_OK(cafe_lib_init());
	CAFE_LOCK();
	CUT_ASSERT_CAFE_OK(cafe_print_configuration_register());
	CUT_ASSERT_CAFE_OK(procfs_cfg_register());
	CUT_ASSERT_CAFE_OK(cafe_ostimer_cfg_register());

	CUT_ASSERT_CAFE_OK(cafe_instrument_create("test_timer", &session));

	spec = cafe_ep_spec_find("ostimer");
	CUT_ASSERT_NOT_NULL(spec);
	settings[0].name = "interval";
	settings[0].value.ull = 100000;
	CUT_ASSERT_CAFE_OK(cafe_ep_inst_create(session, spec,
					       1, settings, &inst[0]));

	spec = cafe_ep_spec_find("procfs");
	CUT_ASSERT_NOT_NULL(spec);
	CUT_ASSERT_CAFE_OK(cafe_ep_inst_create(session, spec,
					       0, NULL, &inst[1]));

	spec = cafe_ep_spec_find("print");
	CUT_ASSERT_NOT_NULL(spec);

	CUT_ASSERT_CAFE_OK(cafe_ep_inst_create(session, spec,
					       0, NULL, &inst[2]));

	CUT_ASSERT_CAFE_OK(cafe_ep_inst_connect(inst[0], inst[1]));
	//CUT_ASSERT_CAFE_OK(cafe_ep_inst_connect(inst[1], inst[2]));
	CUT_ASSERT_CAFE_OK(cafe_inst_enable_all_output_events(inst[0]));
	CUT_ASSERT_CAFE_OK(cafe_inst_enable_all_output_events(inst[1]));
	CUT_ASSERT_CAFE_OK(cafe_instrument_refresh_output_event_actions(session));

	//CUT_ASSERT_CAFE_OK(cafe_ep_inst_print_chain(inst[2], print_flags, true));

	CUT_ASSERT_CAFE_OK(cafe_instrument_start(session));

	CAFE_UNLOCK();
	sleep(1);
	CAFE_LOCK();

	CUT_ASSERT_CAFE_OK(cafe_instrument_stop(session));
	/* clean up, disconnect, and deallocate configurations... */
	CUT_ASSERT_CAFE_OK(cafe_instrument_delete(session));
	CAFE_UNLOCK();
	return 0;
}

CUT_BEGIN_SUITE(procfs_suite)
	CUT_RUN_TEST(test_procfs);
CUT_END_SUITE
