/* user_event_demo.c - example use of Cafe user events */

/* Copyright (c) 2010-2012, 2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
DESCRIPTION
*/

#include <cafe/stdio.h>
#include <cafe/ep/user_event.h>

static const char *numbers[] = {
	"** one **", "** two **", "** three **", "** four **", "** five **"
};

static double dvalues[] = {
	1.0, 3.14159, 1.234e56, -0.1, 1e10
};


void user_event_demo_run(void);
void user_event_demo_run(void)
{
	int value;
	char name[16];
	for (value = 0; value < 5; value++)
		cafe_user_event_unsigned("E1", value);

	for (value = -100; value > -105; value--)
		cafe_user_event_signed("E2", value);

	for (value = 0; value < 5; value++)
		cafe_user_event_string("E3", numbers[value]);

	for (value = 0; value < 5; value++) {
		snprintf(name, sizeof(name), "F%d", value);
		cafe_user_event_float(name, dvalues[value]);
	}
}
