/* vxworks_eventtest.h - */

/*
 * Copyright (c) 2010, 2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
30jun14,sdt  Used atomic variable to handle test_enabled flag
             Add support of PPC decrementer int enter - WB4-3797

DESCRIPTION
*/

#ifndef __vxworks_eventtesth
#define __vxworks_eventtesth

#include <cafe/cafe.h>
#include <cafe/autogenerated/vxworks.type.h>
#include <cafe/ep/vxworks_kernel.h>

#ifdef __cplusplus
extern "C" {
#endif


struct event_data {
	union {
		struct vxWorks_taskDelay taskDelay;
		struct vxWorks_windExitDispatch windExitDispatch;
		struct vxWorks_windDelete windDelete;
		struct vxWorks_taskSpawn taskSpawn;
		struct vxWorks_memPartCreate memPartCreate;
		struct vxWorks_memAlloc memAlloc;
		struct vxWorks_memFree memFree;
		struct vxWorks_memRealloc memRealloc;
		struct vxWorks_intEnter intEnter;
		struct vxWorks_taskName taskName;
		struct cafe_timestamp_config timestampConfig;
		struct cafe_num_cores numCores;
		struct vxWorks_ioCreat ioCreat;
		struct vxWorks_ioOpen ioOpen;
		struct vxWorks_ioClose ioClose;
		struct vxWorks_ioRead ioRead;
		struct vxWorks_ioWrite ioWrite;
		struct vxWorks_ioIoctl ioIoctl;
		struct vxWorks_ioDelete ioDelete;
		struct vxWorks_windPrioritySetRaise windPrioritySetRaise;
		struct vxWorks_windPrioritySetLower windPrioritySetLower;
		struct vxWorks_semMCreate semMCreate;
		struct vxWorks_semCCreate semCCreate;
		struct vxWorks_semBCreate semBCreate;
		struct vxWorks_semDelete semDelete;
		struct vxWorks_semGive semGive;
		struct vxWorks_semTake semTake;
		struct vxWorks_semFlush semFlush;
		struct vxWorks_msgQCreate msgQCreate;
		struct vxWorks_msgQDelete msgQDelete;
		struct vxWorks_msgQSend msgQSend;
		struct vxWorks_msgQRecv msgQRecv;
		struct vxWorks_wdCreate wdCreate;
		struct vxWorks_wdDelete wdDelete;
		struct vxWorks_wdStart wdStart;
		struct vxWorks_wdCancel wdCancel;
		struct vxWorks_objSemGive objSemGive;
		struct vxWorks_objSemTake objSemTake;
		struct vxWorks_objMsgSend objMsgSend;
		struct vxWorks_objMsgReceive objMsgReceive;
		struct vxWorks_objSemRTake objSemRTake;
		struct vxWorks_objSemWTake objSemWTake;
		struct cafe_timestamp timestamp;
		struct cafe_core_id cpu_id;
		struct vxWorks_windSuspend windSuspend;
		struct vxWorks_taskSuspend taskSuspend;
		struct vxWorks_taskPrioritySet taskPrioritySet;
		struct vxWorks_objSigKill objSigKill;
		struct vxWorks_dprintf dprintf;
		struct vxWorks_edrErrorInject edrErrorInject;
		struct vxWorks_eventReceive eventReceive;
		struct vxWorks_eventSend eventSend;
		struct vxWorks_exception exception;
		struct vxWorks_isrCreate isrCreate;
		struct vxWorks_isrDestroy isrDestroy;
		struct vxWorks_isrDispatcherDone isrDispatcherDone;
		struct vxWorks_isrDispatcherInvoke isrDispatcherInvoke;
		struct vxWorks_kill kill;
		struct vxWorks_sdUnmap sdUnmap;
		struct vxWorks_objSemFlush objSemFlush;
		struct vxWorks_rtpTaskSigQueue rtpTaskSigQueue;
		struct vxWorks_rtpSignal rtpSignal;
		struct vxWorks_windCont windCont;
		struct vxWorks_windTickUndelay windTickUndelay;
		struct vxWorks_rtpLoad rtpLoad;
		struct vxWorks_rtpSigQueue rtpSigQueue;
		struct vxWorks_objWindRotate objWindRotate;
		struct vxWorks_taskCpuAffinitySet taskCpuAffinitySet;
		struct vxWorks_windPendQTerminate windPendQTerminate;
		struct vxWorks_windPendQGet windPendQGet;
		struct vxWorks_sdDelete sdDelete;
		struct vxWorks_windWdCancel windWdCancel;
		struct vxWorks_objSigWait objSigWait;
		struct vxWorks_rtpSigTimedWait rtpSigTimedWait;
		struct vxWorks_objMsgDelete objMsgDelete;
		struct vxWorks_pause pause;
		struct vxWorks_signal signal;
		struct vxWorks_rtpSigPending rtpSigPending;
		struct vxWorks_rtpChildWait rtpChildWait;
		struct vxWorks_syscallReturnOk syscallReturnOk;
		struct vxWorks_objOwnerSet objOwnerSet;
		struct vxWorks_windResume windResume;
		struct vxWorks_sdMap sdMap;
		struct vxWorks_syscallReturnError syscallReturnError;
		struct vxWorks_windStop windStop;
		struct vxWorks_taskResume taskResume;
		struct vxWorks_windUndelay windUndelay;
		struct vxWorks_objSigSuspend objSigSuspend;
		struct vxWorks_taskCont taskCont;
		struct vxWorks_windSemDelete windSemDelete;
		struct vxWorks_rtpName rtpName;
		struct vxWorks_windPendQFlush windPendQFlush;
		struct vxWorks_rtpSigProcMask rtpSigProcMask;
		struct vxWorks_sdCreate sdCreate;
		struct vxWorks_windSpawn windSpawn;
		struct vxWorks_sigWrapper sigWrapper;
		struct vxWorks_semRTake semRTake;
		struct vxWorks_objSigPause objSigPause;
		struct vxWorks_taskSafe taskSafe;
		struct vxWorks_rtpKill rtpKill;
		struct vxWorks_windTickTimeout windTickTimeout;
		struct vxWorks_sigSuspend sigSuspend;
		struct vxWorks_syscallBadId syscallBadId;
		struct vxWorks_rtpDelete rtpDelete;
		struct vxWorks_windWdStart windWdStart;
		struct vxWorks_windTickAnnounceTmrWd windTickAnnounceTmrWd;
		struct vxWorks_taskDestroy taskDestroy;
		struct vxWorks_taskStop taskStop;
		struct vxWorks_rtpSpawn rtpSpawn;
		struct vxWorks_rtpSuspend rtpSuspend;
		struct vxWorks_rtpSigWrapperDone rtpSigWrapperDone;
		struct vxWorks_semWTake semWTake;
		struct vxWorks_isrInfo isrInfo;
		struct vxWorks_semRWCreate semRWCreate;
		struct vxWorks_semMGiveForce semMGiveForce;
		struct vxWorks_rtpTaskKill rtpTaskKill;
		struct vxWorks_taskUnsafe taskUnsafe;
		struct vxWorks_rtpPause rtpPause;
		struct vxWorks_rtpInitTask rtpInitTask;
		struct vxWorks_windDelay windDelay;
		struct vxWorks_rtpSigWrapper rtpSigWrapper;
		struct vxWorks_taskRotate taskRotate;
		struct vxWorks_memAddToPool memAddToPool;
		struct vxWorks_moduleLoad moduleLoad;
		struct vxWorks_moduleUnload moduleUnload;
		struct vxWorks_rtpUnload rtpUnload;
	    } u;
};

extern int intEnter_test (struct cafe_instrument *session);
extern int intExit_test (struct cafe_instrument *session, int k);
extern int tickAnnounce_test (struct cafe_instrument *session);
extern int taskSpawn_test (struct cafe_instrument *session);
extern int taskDelay_test (struct cafe_instrument *session);
extern int memAlloc_test (struct cafe_instrument *session);
extern int memRealloc_test (struct cafe_instrument *session);
extern int memFree_test (struct cafe_instrument *session);
extern int memPartCreate_test (struct cafe_instrument *session);
extern int taskLockUnlock_test (struct cafe_instrument *session, int lock);
extern int windExitDispatch_test (struct cafe_instrument *session, int pi);
extern int windExitIdle_test (struct cafe_instrument *session);
extern int windDelete_test (struct cafe_instrument *session);
extern int taskName_test (struct cafe_instrument *session);
extern int taskNameAtStart_test(struct cafe_instrument *session,
				struct cafe_ep_inst *inst);
extern int timestampConfig_test (struct cafe_instrument *session,
				 struct cafe_ep_inst *vxworks);
extern int numCores_test(struct cafe_instrument *session,
			 struct cafe_ep_inst *inst);
extern void ioTests_treadown (void);
extern int ioOpen_test (struct cafe_instrument *session);
extern int ioCreat_test (struct cafe_instrument *session);
extern int ioClose_test (struct cafe_instrument *session);
extern int ioRead_test (struct cafe_instrument *session);
extern int ioWrite_test (struct cafe_instrument *session);
extern int ioIoctl_test (struct cafe_instrument *session);
extern int ioDelete_test (struct cafe_instrument *session);
extern void semTests_treadown (void);
extern int semBCreate_test (struct cafe_instrument *session);
extern int semCCreate_test (struct cafe_instrument *session);
extern int semMCreate_test (struct cafe_instrument *session);
extern int semDelete_test (struct cafe_instrument *session);
extern int semGive_test (struct cafe_instrument *session);
extern int semTake_test (struct cafe_instrument *session);
extern int semFlush_test (struct cafe_instrument *session);
extern int msgQSend_test (struct cafe_instrument *session);
extern int msgQRecv_test (struct cafe_instrument *session);
extern int msgQCreate_test (struct cafe_instrument *session);
extern int msgQDelete_test (struct cafe_instrument *session);
extern int wdCreate_test (struct cafe_instrument *session);
extern int wdDelete_test (struct cafe_instrument *session);
extern int wdStart_test (struct cafe_instrument *session);
extern int wdCancel_test (struct cafe_instrument *session);
extern int objMsgSend_test (struct cafe_instrument *session);
extern int objMsgReceive_test (struct cafe_instrument *session);
extern int numCoresOnEnableDisable_test(struct cafe_instrument *session,
					struct cafe_ep_inst *inst, int enable);
extern int windSuspend_test (struct cafe_instrument *session);
extern int taskSuspend_test (struct cafe_instrument *session);
extern int taskPrioritySet_test (struct cafe_instrument *session);
extern int objSigKill_test (struct cafe_instrument *session);

extern int dprintf_test (struct cafe_instrument *session);
extern int edrErrorInject_test (struct cafe_instrument *session);
extern int eventReceive_test (struct cafe_instrument *session);
extern int eventSend_test (struct cafe_instrument *session);
extern int exception_test (struct cafe_instrument *session);
extern int isrCreate_test (struct cafe_instrument *session);
extern int isrDestroy_test (struct cafe_instrument *session);
extern int isrDispatcherDone_test (struct cafe_instrument *session);
extern int isrDispatcherInvoke_test (struct cafe_instrument *session);
extern int kill_test (struct cafe_instrument *session);
extern int sdUnmap_test(struct cafe_instrument *session);
extern int objSemFlush_test(struct cafe_instrument *session);
extern int rtpTaskSigQueue_test(struct cafe_instrument *session);
extern int rtpSignal_test(struct cafe_instrument *session);
extern int windCont_test(struct cafe_instrument *session);
extern int windTickUndelay_test(struct cafe_instrument *session);
extern int exception_test(struct cafe_instrument *session);
extern int rtpLoad_test(struct cafe_instrument *session);
extern int rtpSigQueue_test(struct cafe_instrument *session);
extern int objWindRotate_test(struct cafe_instrument *session);
extern int taskCpuAffinitySet_test(struct cafe_instrument *session);
extern int windPendQTerminate_test(struct cafe_instrument *session);
extern int sdDelete_test(struct cafe_instrument *session);
extern int kill_test(struct cafe_instrument *session);
extern int windWdCancel_test(struct cafe_instrument *session);
extern int objSigwait_test(struct cafe_instrument *session);
extern int rtpSigTimedWait_test(struct cafe_instrument *session);
extern int objMsgDelete_test(struct cafe_instrument *session);
extern int objEventReceive_test(struct cafe_instrument *session);
extern int pause_test(struct cafe_instrument *session);
extern int signal_test(struct cafe_instrument *session);
extern int rtpSigPending_test(struct cafe_instrument *session);
extern int rtpChildWait_test(struct cafe_instrument *session);
extern int syscallReturnOk_test(struct cafe_instrument *session);
extern int objOwnerSet_test(struct cafe_instrument *session);
extern int windResume_test(struct cafe_instrument *session);
extern int sdMap_test(struct cafe_instrument *session);
extern int syscallReturnErr_test(struct cafe_instrument *session);
extern int eventReceive_test(struct cafe_instrument *session);
extern int windStop_test(struct cafe_instrument *session);
extern int taskResume_test(struct cafe_instrument *session);
extern int windUndelay_test(struct cafe_instrument *session);
extern int objSigSuspend_test(struct cafe_instrument *session);
extern int taskCont_test(struct cafe_instrument *session);
extern int windSemDelete_test(struct cafe_instrument *session);
extern int rtpName_test(struct cafe_instrument *session);
extern int windPendQFlush_test(struct cafe_instrument *session);
extern int rtpSigProcMask_test(struct cafe_instrument *session);
extern int sdCreate_test(struct cafe_instrument *session);
extern int windSpawn_test(struct cafe_instrument *session);
extern int sigWrapper_test(struct cafe_instrument *session);
extern int semRTake_test(struct cafe_instrument *session);
extern int objSigPause_test(struct cafe_instrument *session);
extern int taskSafe_test(struct cafe_instrument *session);
extern int rtpKill_test(struct cafe_instrument *session);
extern int windTickTimeout_test(struct cafe_instrument *session);
extern int sigSuspend_test(struct cafe_instrument *session);
extern int syscallBadId_test(struct cafe_instrument *session);
extern int rtpDelete_test(struct cafe_instrument *session);
extern int windWdStart_test(struct cafe_instrument *session);
extern int eventSend_test(struct cafe_instrument *session);
extern int windTickAnnounceTmrWd_test(struct cafe_instrument *session);
extern int taskDestroy_test(struct cafe_instrument *session);
extern int taskStop_test(struct cafe_instrument *session);
extern int rtpSpawn_test(struct cafe_instrument *session);
extern int rtpSuspend_test(struct cafe_instrument *session);
extern int rtpSigWrapperDone_test(struct cafe_instrument *session);
extern int semWTake_test(struct cafe_instrument *session);
extern int isrInfo_test(struct cafe_instrument *session);
extern int semRWCreate_test(struct cafe_instrument *session);
extern int semMGiveForce_test(struct cafe_instrument *session);
extern int rtpTaskKill_test(struct cafe_instrument *session);
extern int windTickAnnounceTmrSlc_test(struct cafe_instrument *session);
extern int taskUnsafe_test(struct cafe_instrument *session);
extern int objEventSend_test(struct cafe_instrument *session);
extern int timerRollover_test(struct cafe_instrument *session);
extern int rtpPause_test(struct cafe_instrument *session);
extern int objVerifyFail_test(struct cafe_instrument *session);
extern int rtpInitTask_test(struct cafe_instrument *session);
extern int windDelay_test(struct cafe_instrument *session);
extern int rtpSigWrapper_test(struct cafe_instrument *session);
extern int taskRotate_test(struct cafe_instrument *session);
extern int windPrioritySetRaise_test (struct cafe_instrument *session);
extern int windPrioritySetLower_test (struct cafe_instrument *session);
extern int windPendQGet_test(struct cafe_instrument *session);
extern int objSemGive_test(struct cafe_instrument *session);
extern int objSemTake_test(struct cafe_instrument *session);
extern int objSemRTake_test(struct cafe_instrument *session);
extern int objSemWTake_test(struct cafe_instrument *session);
extern int objSigWait_test(struct cafe_instrument *session);
extern int memAddToPool_test(struct cafe_instrument *session);
extern int syscallReturnError_test(struct cafe_instrument *session);
extern int moduleLoad_test(struct cafe_instrument *session);
extern int moduleUnload_test(struct cafe_instrument *session);
extern int rtpUnload_test(struct cafe_instrument *session);
extern int kernelOnStart_test(struct cafe_instrument *session,
			      struct cafe_ep_inst *inst);

#if defined(__VXWORKS__)
    #include <vxAtomicLib.h>
    typedef atomic_t			TEST_ENA_T;
    #define IS_TEST_ENABLE		(vxAtomicGet(&test_enabled))
    #define TEST_ENABLE_SET(state)	vxAtomicSet(&test_enabled, state);
#else
    typedef int			TEST_ENA_T;
    #define IS_TEST_ENABLE		(test_enabled)
    #define TEST_ENABLE_SET(state)	test_enabled = state;
#endif

extern TEST_ENA_T test_enabled;
extern struct cafe_value_type *expected_type;

extern const char *taskDelay_TYPE[];
extern const char *taskSpawn_TYPE[];
extern const char *memAlloc_TYPE[];
extern const char *memFree_TYPE[];
extern const char *memRealloc_TYPE[];
extern const char *memPartCreate_TYPE[];
extern const char *intEnter_TYPE[];
#if defined(__VXWORKS__) && (_VX_CPU_FAMILY == _VX_PPC)
extern const char *intEnterPpcDec_TYPE[];
#endif
extern const char *intExit_TYPE[];
extern const char *intExitK_TYPE[];
extern const char *tickAnnounce_TYPE[];
extern const char *taskLock_TYPE[];

#if (_WRS_VXWORKS_MAJOR > 6) || \
	((_WRS_VXWORKS_MAJOR == 6) && (_WRS_VXWORKS_MINOR > 8)) || \
    ((_WRS_VXWORKS_MAJOR == 6) && (_WRS_VXWORKS_MINOR == 8) && (_WRS_VXWORKS_MAINT >= 2))
extern const char *taskUnlockZero_TYPE[];
extern const char *taskUnlockNonZero_TYPE[];
#else
extern const char *taskUnlock_TYPE[];
#endif

extern const char *windExitDispatch_TYPE[];
extern const char *windExitDispatchPI_TYPE[];
extern const char *windExitIdle_TYPE[];
extern const char *windDelete_TYPE[];
extern const char *taskName_TYPE[];
extern const char *timestampConfig_TYPE[];
extern const char *numCores_TYPE[];
extern const char *ioCreat_TYPE[];
extern const char *ioOpen_TYPE[];
extern const char *ioClose_TYPE[];
extern const char *ioRead_TYPE[];
extern const char *ioWrite_TYPE[];
extern const char *ioIoctl_TYPE[];
extern const char *ioDelete_TYPE[];
extern const char *windPrioritySetRaise_TYPE[];
extern const char *windPrioritySetLower_TYPE[];
extern const char *semCCreate_TYPE[];
extern const char *semMCreate_TYPE[];
extern const char *semBCreate_TYPE[];
extern const char *semDelete_TYPE[];
extern const char *semGive_TYPE[];
extern const char *semTake_TYPE[];
extern const char *semFlush_TYPE[];
extern const char *msgQSend_TYPE[];
extern const char *msgQRecv_TYPE[];
extern const char *msgQCreate_TYPE[];
extern const char *msgQDelete_TYPE[];
extern const char *wdCreate_TYPE[];
extern const char *wdDelete_TYPE[];
extern const char *wdStart_TYPE[];
extern const char *wdCancel_TYPE[];
extern const char *objSemGive_TYPE[];
extern const char *objSemTake_TYPE[];
extern const char *objMsgSend_TYPE[];
extern const char *objMsgReceive_TYPE[];
extern const char *objSemRTake_TYPE[];
extern const char *objSemWTake_TYPE[];
extern const char *windSuspend_TYPE[];
extern const char *taskSuspend_TYPE[];
extern const char *taskPrioritySet_TYPE[];
extern const char *objSigKill_TYPE[];

extern const char *dprintf_TYPE[];
extern const char *edrErrorInject_TYPE[];
extern const char *eventReceive_TYPE[];
extern const char *eventSend_TYPE[];
extern const char *exception_TYPE[];
extern const char *isrCreate_TYPE[];
extern const char *isrDestroy_TYPE[];
extern const char *isrDispatcherDone_TYPE[];
extern const char *isrDispatcherInvoke_TYPE[];
extern const char *kill_TYPE[];
extern const char *isrInfo_TYPE[];
extern const char *rtpName_TYPE[];
extern const char *windSpawn_TYPE[];
extern const char *windResume_TYPE[];
extern const char *taskCpuAffinitySet_TYPE[];
extern const char *semWTake_TYPE[];
extern const char *semRTake_TYPE[];
extern const char *semRWCreate_TYPE[];
extern const char *sdUnmap_TYPE[];
extern const char *sdMap_TYPE[];
extern const char *sdCreate_TYPE[];
extern const char *rtpSigProcMask_TYPE[];
extern const char *rtpSigPending_TYPE[];
extern const char *rtpSigWrapper_TYPE[];
extern const char *objSigPause_TYPE[];
extern const char *objSemFlush_TYPE[];
extern const char *windSemDelete_TYPE[];
extern const char *windTickUndelay_TYPE[];
extern const char *windPendQGet_TYPE[];
extern const char *windTickAnnounceTmrSlc_TYPE[];
extern const char *windTickAnnounceTmrWd_TYPE[];
extern const char *windPendQGet_TYPE[];
extern const char *windWdStart_TYPE[];
extern const char *windUndelay_TYPE[];
extern const char *windDelay_TYPE[];
extern const char *windWdCancel_TYPE[];
extern const char *windPendQFlush_TYPE[];
extern const char *windPendQTerminate_TYPE[];
extern const char *sdDelete_TYPE[];
extern const char *taskRotate_TYPE[];
extern const char *rtpChildWait_TYPE[];

extern const char *syscallReturnError_TYPE[];
extern const char *syscallBadId_TYPE[];
extern const char *objVerifyFail_TYPE[];
extern const char *rtpSpawn_TYPE[];
extern const char *rtpDelete_TYPE[];
extern const char *rtpInitTask_TYPE[];
extern const char *rtpLoad_TYPE[];
extern const char *rtpKill_TYPE[];
extern const char *rtpSignal_TYPE[];
extern const char *rtpSuspend_TYPE[];
extern const char *rtpPause_TYPE[];
extern const char *rtpTaskKill_TYPE[];
extern const char *rtpSigQueue_TYPE[];
extern const char *rtpTaskSigQueue_TYPE[];
extern const char *rtpSigTimedWait_TYPE[];
extern const char *rtpSigWrapperDone_TYPE[];
extern const char *semRWCreate_TYPE[];
extern const char *windStop_TYPE[];
extern const char *windCont_TYPE[];
extern const char *objSigSuspend_TYPE[];
extern const char *objSigWait_TYPE[];
extern const char *objEventSend_TYPE[];
extern const char *taskDestroy_TYPE[];
extern const char *objEventReceive_TYPE[];
extern const char *objWindRotate_TYPE[];
extern const char *taskResume_TYPE[];
extern const char *taskSafe_TYPE[];
extern const char *taskUnsafe_TYPE[];
extern const char *msgQReceive_TYPE[];
extern const char *signal_TYPE[];
extern const char *sigSuspend_TYPE[];
extern const char *sigWrapper_TYPE[];
extern const char *memAddToPool_TYPE[];
extern const char *taskStop_TYPE[];
extern const char *taskCont_TYPE[];
extern const char *objMsgDelete_TYPE[];
extern const char *windTickTimeout_TYPE[];
extern const char *semMGiveForce_TYPE[];
extern const char *pause_TYPE[];
extern const char *objOwnerSet_TYPE[];
extern const char *syscallReturnOk_TYPE[];
extern const char *timerRollover_TYPE[];
extern const char *moduleLoad_TYPE[];
extern const char *moduleUnload_TYPE[];
extern const char *rtpUnload_TYPE[];

/*
  Allow action handler to store events into a short log for later
*/

#define MAX_STORED_EVENTS	256
#define MAX_TYPES_PER_EVENT     4

struct logged_event {
	unsigned int num_types;
	struct cafe_value_type *types[MAX_TYPES_PER_EVENT];
	struct event_data event_data[MAX_TYPES_PER_EVENT];
};

extern unsigned int logged_event_count;

extern struct logged_event logged_events[];

extern void reset_logged_events(void);

#ifdef __cplusplus
}
#endif


#endif /* __vxworks_eventtesth */
