/* vxworks_events.h - vxWorks event definitions for Cafe */

/*
 * Copyright (c) 2010-2012 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
This file describes the allocation of vxWorks event Ids. It must match that
defined in the vxWorks source
*/

#ifndef __vxworks_eventsh
#define __vxworks_eventsh

#if defined(__VXWORKS__)
#include <vxWorks.h>
#include <private/eventDefsP.h>
#else

#ifdef __cplusplus
extern "C" {
#endif

#ifndef CONTROL_EVENT
#define CONTROL_EVENT(x) x
#endif

#ifndef CLASS1_EVENT
#define CLASS1_EVENT(x) (50+x)
#endif

#ifndef CLASS2_EVENT
#define CLASS2_EVENT(x) (600+x)
#endif

#ifndef CLASS3_EVENT
#define CLASS3_EVENT(x) (10000+x)
#endif

#ifndef EVENT_INT_EXIT_K
#define EVENT_INT_EXIT_K		100
#endif

#ifndef EVENT_INT_EXIT
#define EVENT_INT_EXIT			101
#endif

#ifndef EVENT_INT_ENTER
#define EVENT_INT_ENTER			102
#endif

#define EVENT_TIMER_ROLLOVER  	        CONTROL_EVENT(2)
#define	EVENT_TASKNAME			CONTROL_EVENT(3)
#define	EVENT_TIMESTAMP_CONFIG		CONTROL_EVENT(8)
#define EVENT_ISR_INFO                  CONTROL_EVENT(9)
#define	EVENT_CPU_ID			CONTROL_EVENT(10)
#define	EVENT_RTPNAME			CONTROL_EVENT(16)
#define	EVENT_NUM_CPU			CONTROL_EVENT(17)

#define	EVENT_WIND_EXIT_DISPATCH	CLASS1_EVENT(2)
#define	EVENT_WIND_EXIT_DISPATCH_PI	CLASS1_EVENT(4)
#define EVENT_WIND_EXIT_IDLE		CLASS1_EVENT(6)
#define	EVENT_TASKLOCK	  		CLASS1_EVENT(7)
#define	EVENT_TASKUNLOCK  		CLASS1_EVENT(8)
#define EVENT_TICKANNOUNCE		CLASS1_EVENT(9)
#define	EVENT_EXCEPTION			CLASS1_EVENT(10)
#define EVENT_TASKUNLOCKZERO		CLASS1_EVENT(24)
#define EVENT_TASKUNLOCKNONZERO		CLASS1_EVENT(25)

#define EVENT_WINDSPAWN			CLASS2_EVENT(0)
#define EVENT_WINDDELETE   		CLASS2_EVENT(1)
#define	EVENT_WINDSUSPEND		CLASS2_EVENT(2)
#define	EVENT_WINDRESUME		CLASS2_EVENT(3)
#define EVENT_WINDPRIORITYSETRAISE	CLASS2_EVENT(4)
#define EVENT_WINDPRIORITYSETLOWER	CLASS2_EVENT(5)
#define	EVENT_WINDSEMDELETE		CLASS2_EVENT(6)
#define	EVENT_WINDTICKANNOUNCETMRSLC	CLASS2_EVENT(7)
#define	EVENT_WINDTICKANNOUNCETMRWD	CLASS2_EVENT(8)
#define	EVENT_WINDDELAY			CLASS2_EVENT(9)
#define	EVENT_WINDUNDELAY		CLASS2_EVENT(10)
#define	EVENT_WINDWDSTART		CLASS2_EVENT(11)
#define	EVENT_WINDWDCANCEL		CLASS2_EVENT(12)
#define	EVENT_WINDPENDQGET		CLASS2_EVENT(13)
#define	EVENT_WINDPENDQFLUSH		CLASS2_EVENT(14)
#define	EVENT_WINDPENDQPUT		CLASS2_EVENT(15)
#define	EVENT_WINDPENDQTERMINATE	CLASS2_EVENT(17)
#define	EVENT_WINDTICKUNDELAY		CLASS2_EVENT(18)
#define EVENT_OBJ_SEMGIVE		CLASS2_EVENT(20)
#define EVENT_OBJ_SEMTAKE		CLASS2_EVENT(21)
#define EVENT_OBJ_SEMFLUSH		CLASS2_EVENT(22)
#define EVENT_OBJ_MSGSEND		CLASS2_EVENT(23)
#define EVENT_OBJ_MSGRECEIVE		CLASS2_EVENT(24)
#define EVENT_OBJ_MSGDELETE		CLASS2_EVENT(25)
#define EVENT_OBJ_SIGPAUSE		CLASS2_EVENT(26)
#define EVENT_OBJ_SIGSUSPEND		CLASS2_EVENT(27)
#define EVENT_OBJ_SIGKILL		CLASS2_EVENT(28)
#define	EVENT_WINDSTOP			CLASS2_EVENT(29)
#define	EVENT_WINDCONT			CLASS2_EVENT(30)
#define EVENT_WINDTICKTIMEOUT           CLASS2_EVENT(31)
#define EVENT_OBJ_SIGWAIT               CLASS2_EVENT(32)
#define	EVENT_OBJ_EVENTSEND		CLASS2_EVENT(35)
#define	EVENT_OBJ_EVENTRECEIVE		CLASS2_EVENT(36)
#define EVENT_OBJ_WINDROTATE           	CLASS2_EVENT(46)
#define EVENT_OBJ_SEMRTAKE		CLASS2_EVENT(47)
#define EVENT_OBJ_SEMWTAKE		CLASS2_EVENT(48)

#define EVENT_TASKSPAWN   		CLASS3_EVENT(0)
#define	EVENT_TASKDESTROY		CLASS3_EVENT(1)
#define EVENT_TASKDELAY   		CLASS3_EVENT(2)
#define	EVENT_TASKPRIORITYSET	        CLASS3_EVENT(3)
#define	EVENT_TASKSUSPEND		CLASS3_EVENT(4)
#define	EVENT_TASKRESUME		CLASS3_EVENT(5)
#define	EVENT_TASKSAFE			CLASS3_EVENT(6)
#define	EVENT_TASKUNSAFE		CLASS3_EVENT(7)
#define EVENT_SEMBCREATE		CLASS3_EVENT(8)
#define EVENT_SEMCCREATE		CLASS3_EVENT(9)
#define EVENT_SEMDELETE			CLASS3_EVENT(10)
#define EVENT_SEMFLUSH			CLASS3_EVENT(11)
#define EVENT_SEMGIVE			CLASS3_EVENT(12)
#define EVENT_SEMMCREATE		CLASS3_EVENT(13)
#define	EVENT_SEMMGIVEFORCE		CLASS3_EVENT(14)
#define EVENT_SEMTAKE			CLASS3_EVENT(15)
#define EVENT_WDCREATE			CLASS3_EVENT(16)
#define EVENT_WDDELETE			CLASS3_EVENT(17)
#define EVENT_WDSTART			CLASS3_EVENT(18)
#define EVENT_WDCANCEL			CLASS3_EVENT(19)
#define EVENT_MSGQCREATE		CLASS3_EVENT(20)
#define EVENT_MSGQDELETE		CLASS3_EVENT(21)
#define EVENT_MSGQRECEIVE		CLASS3_EVENT(22)
#define EVENT_MSGQSEND			CLASS3_EVENT(23)
#define	EVENT_SIGNAL			CLASS3_EVENT(24)
#define	EVENT_SIGSUSPEND		CLASS3_EVENT(25)
#define	EVENT_PAUSE			CLASS3_EVENT(26)
#define	EVENT_KILL			CLASS3_EVENT(27)
#define EVENT_SAFE_PEND                 CLASS3_EVENT(28)
#define EVENT_SIGWRAPPER                CLASS3_EVENT(29)
#define EVENT_MEMALLOC    		CLASS3_EVENT(30)
#define EVENT_MEMFREE     		CLASS3_EVENT(31)
#define EVENT_MEMPARTCREATE		CLASS3_EVENT(32)
#define EVENT_MEMREALLOC		CLASS3_EVENT(33)
#define EVENT_MEMADDTOPOOL		CLASS3_EVENT(34)
#define	EVENT_TASKSTOP			CLASS3_EVENT(43)
#define	EVENT_TASKCONT			CLASS3_EVENT(44)
#define EVENT_IOOPEN			CLASS3_EVENT(48)
#define EVENT_IOREAD			CLASS3_EVENT(49)
#define EVENT_IOWRITE			CLASS3_EVENT(50)
#define EVENT_IOIOCTL			CLASS3_EVENT(51)
#define EVENT_IOCLOSE			CLASS3_EVENT(52)
#define EVENT_IOCREAT			CLASS3_EVENT(53)
#define EVENT_IODELETE			CLASS3_EVENT(54)
#define EVENT_EVENTSEND			CLASS3_EVENT(57)
#define EVENT_EVENTRECEIVE		CLASS3_EVENT(58)
#define EVENT_OWNERSET			CLASS3_EVENT(59)
#define EVENT_ISR_DISPATCHER_INVOKE	CLASS3_EVENT(60)
#define EVENT_ISR_DISPATCHER_DONE	CLASS3_EVENT(61)
#define EVENT_ISR_CREATE		CLASS3_EVENT(62)
#define EVENT_ISR_DESTROY		CLASS3_EVENT(64)
#define EVENT_SYSCALL_RETURN_OK         CLASS3_EVENT(74)
#define EVENT_SYSCALL_RETURN_ERR        CLASS3_EVENT(75)
#define EVENT_SYSCALL_BAD_ID            CLASS3_EVENT(76)
#define EVENT_OBJ_VERIFY_FAIL          	CLASS3_EVENT(77)
#define EVENT_RTP_SPAWN                	CLASS3_EVENT(78)
#define EVENT_RTP_DELETE               	CLASS3_EVENT(79)
#define EVENT_RTP_INIT_TASK            	CLASS3_EVENT(80)
#define EVENT_RTP_LOAD                 	CLASS3_EVENT(81)
#define EVENT_EDR_ERROR_INJECT         	CLASS3_EVENT(82)
#define EVENT_RTPKILL                   CLASS3_EVENT(83)
#define EVENT_RTPSIGNAL                 CLASS3_EVENT(84)
#define EVENT_RTPSUSPEND                CLASS3_EVENT(85)
#define EVENT_RTPPAUSE                  CLASS3_EVENT(86)
#define EVENT_RTPTASKKILL               CLASS3_EVENT(87)
#define EVENT_RTPSIGQUEUE               CLASS3_EVENT(88)
#define EVENT_RTPTASKSIGQUEUE           CLASS3_EVENT(89)
#define EVENT_RTPCHILDWAIT              CLASS3_EVENT(90)
#define EVENT_RTPSIGTIMEDWAIT           CLASS3_EVENT(91)
#define EVENT_RTPSIGWRAPPER             CLASS3_EVENT(92)
#define EVENT_RTPSIGWRAPPER_DONE       	CLASS3_EVENT(93)
#define EVENT_RTPSIGPROCMASK            CLASS3_EVENT(94)
#define EVENT_RTPSIGPENDING             CLASS3_EVENT(95)
#define	EVENT_TASKROTATE		CLASS3_EVENT(108)
#define EVENT_SD_CREATE                	CLASS3_EVENT(200)
#define EVENT_SD_DELETE                	CLASS3_EVENT(201)
#define EVENT_SD_MAP                   	CLASS3_EVENT(202)
#define EVENT_SD_UNMAP                 	CLASS3_EVENT(203)
#define EVENT_SEMRWCREATE               CLASS3_EVENT(204)
#define EVENT_SEMRTAKE                  CLASS3_EVENT(205)
#define EVENT_SEMWTAKE                  CLASS3_EVENT(206)
#define EVENT_TASK_CPU_AFFINITY_SET    	CLASS3_EVENT(230)
#define EVENT_DPRINTF_LOG		CLASS3_EVENT(239)

#define MAX_USER_ID 			0x10000
#endif  /* if defined(__VXWORKS__) */

#ifndef SV_EVENT_USERLEVEL_START

#define SV_EVENT_USERLEVEL_START	15000
#define SV_EVENT_USERLEVEL(n)	        (SV_EVENT_USERLEVEL_START + n)

#endif

#define EVENT_RTPMEMALLOC		SV_EVENT_USERLEVEL(0)
#define EVENT_RTPMEMFREE		SV_EVENT_USERLEVEL(1)
#define EVENT_RTPMEMPARTCREATE		SV_EVENT_USERLEVEL(2)
#define EVENT_RTPMEMREALLOC		SV_EVENT_USERLEVEL(3)
#define EVENT_RTPMEMADDTOPOOL		SV_EVENT_USERLEVEL(4)


#define VXWORKS_MAX_EVENT_ID		MAX_USER_ID
#define CAFE_BASE_EVENT			(MAX_USER_ID + 1)

/* Events which are defined only for Cafe */
#define CAFE_EVENT(x) (CAFE_BASE_EVENT + x)


#define EVENT_CAFE_MODULE_LOAD		CAFE_EVENT(1)
#define EVENT_CAFE_MODULE_UNLOAD	CAFE_EVENT(2)
#define EVENT_CAFE_RTP_UNLOAD		CAFE_EVENT(3)

#ifdef __cplusplus
}
#endif

#endif /* __vxworks_eventsh */
