/* cafe_lib.c - register intrinsic cafe configurations. */

/* Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

#include "cafe_os.h"
#include <cafe/cafe.h>
#include <cafe/stdbool.h>
#include "cafe_trace.h"
#include "cafe_assert.h"

static bool initialized = false;

int cafe_lib_init(void)
{
	int rc;

	if (initialized)
		return CAFE_OK;

	if ((rc = cafe_lock_init()) != CAFE_OK)
		return rc;

	/*
	 * If "CAFE_TRACE" is in the environment then take that as a
	 * positive request to turn tracing on, irrespective of its
	 * value.
	 */
	cafe_trace = getenv("CAFE_TRACE") != NULL;

	initialized = true;

	return CAFE_OK;
}

void cafe_lib_release(void)
{
	if (!initialized)
		return;

	assert(!cafe_islocked());
	initialized = false;
}
