/* cafe_os_unix.h - Cafe OS primitives for UN*X platforms. */

/*
 * Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

#ifndef INCcafe_os_unix_h
#define INCcafe_os_unix_h

#ifndef _LARGEFILE_SOURCE
#error "Need CC command line option: -D_LARGEFILE_SOURCE"
#endif
#ifndef _GNU_SOURCE
#error "Need CC command line option: -D_GNU_SOURCE"
#endif

#define cafe_sched_yield sched_yield

#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h>		/* clock_gettime/gettimeofday */
#include <pthread.h>
#include <unistd.h>		/* getpagesize */

#ifdef __APPLE__

typedef enum {
    CLOCK_REALTIME
} clockid_t;

extern int clock_gettime(clockid_t clk_id, struct timespec *tp);

#endif	/* __APPLE__ */

#endif	/* INCcafe_os_unix_h */
