if(CMAKE_COMPILER_IS_GNUCC)
  set(GNUCC_CFLAGS "-Wall -Wformat -Wreturn-type -Wswitch -Wcomment -Wchar-subscripts -Wparentheses -Wpointer-arith -Wwrite-strings -Waggregate-return -Wmissing-prototypes -Wswitch-enum -Wunused -Wno-unused-parameter")
  check_c_compiler_flag(-Wstrict-overflow GCC_STRICT_OVERFLOW)
  if(NOT ALLOW_COMPILE_WARNINGS)
    set(GNUCC_CFLAGS "${GNUCC_CFLAGS} -Werror")
  endif()
  if(GCC_STRICT_OVERFLOW)
    # See: http://www.airs.com/blog/archives/120
    set(GNUCC_CFLAGS "${GNUCC_CFLAGS} -Wstrict-overflow=1")
  endif()
  if(CMAKE_CROSSCOMPILING AND MINGW)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GNUCC_CFLAGS}")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GNUCC_CFLAGS} -fPIC -DPIC")
  endif()
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-inline")
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -g")
endif()
