/* cafe-code.h - example Phoenix coding conventions style */

/*
 * Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
DESCRIPTION

The Phoenix coding convention follows the Linux kernel coding convention.
This file is in addition to that and it attempts to lay out a common style
giving all Phoenix code the same look and feel. Linux coding conventions
are not repeated here.

INCLUDE FILES:
*/

#ifndef INCcafe_code_h
#define INCcafe_code_h

#ifdef __cplusplus
extern "C" {
#endif

struct cafe_fruits;

/******************************************************************************
 *
 * cafe_get_num_fruits - Fill in number of fruits structure
 *
 * This paragraph describes what the function does
 *
 * INTERNAL
 * Resolution is always assumed to be less than 1 second -- only
 * the tv_nsec field is filled in.
 *
 * RETURNS:
 * Pointer to new data structure or NULL.
 *
 * ERRNO:
 *
 * SEE ALSO:
 */

struct cafe_fruits *cafe_get_num_of_fruits
	(
	unsigned int	num_oranges,		/* number of oranges */
	int		num_pears,		/* number of pears */
	int		num_apples,		/* number of apples */
	unsigned int	*num_of_blue_berries	/* number of blue berries */
	);

#ifdef __cplusplus
}
#endif
#endif /* INCcafe_code_h */
