;;; A simple mode for cafe script files.

;; To enable this mode copy this file to a location that Emacs can
;; find it (i.e., on your load-path) and add the following to your
;; .emacs.el.
;;
;; (require 'cafe-script-mode)

(defconst cafe-script-keywords
  '("create"
    "as"
    "enable"
    "for"
    "to"
    "connect"
    "table"
    "action"
    "typedef"
    "type"
    "source"
    )
  "Cafe RSP keywords.")

(defconst cafe-script-operations
  '("aggregate"
    "avg"
    "clear"
    "count"
    "delete"
    "max"
    "min"
    "mm_clear"
    "mm_clone"
    "mm_delete"
    "mm_delta"
    "mm_update"
    "reset"
    "sendtoself"
    "set"
    "snapshot"
    "stop_dispatch"
    "sum")
  "Cafe RSP operations")

(defconst cafe-script-keywords-regexp (regexp-opt cafe-script-keywords 'words))
(defconst cafe-script-operations-regexp (regexp-opt cafe-script-operations 'words))

(setq cafe-script-font-lock-keywords
      `(
	("^#.*$" . font-lock-comment-face)
	("^set\s-?" . font-lock-keyword-face)
        ("\\[\\(cafe\\.[^],]+\\)" . (1 font-lock-builtin-face))
        ;;("^typedef\\s-*\\(\\w+\\)" . (1 font-lock-type-face))
	(,cafe-script-keywords-regexp . font-lock-keyword-face)
	(,cafe-script-operations-regexp . font-lock-constant-face)
        ))

;; define the mode
(define-derived-mode cafe-script-mode text-mode
  "Major mode for editing Cafe script files."
  (setq case-fold-search nil)
  (modify-syntax-entry ?_ "w" cafe-script-mode-syntax-table)
  (modify-syntax-entry ?. "w" cafe-script-mode-syntax-table)
  (setq font-lock-defaults '((cafe-script-font-lock-keywords)))
  )

(add-to-list 'auto-mode-alist '("\\.instrument\\'" . cafe-script-mode))
(add-to-list 'auto-mode-alist '("\\.types\\'" . cafe-script-mode))

(provide 'cafe-script-mode)

