/* Copyright (c) 2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
09sep14,wzc  support arm hpc events.(US17715)
28mar14,sdt  fixed build issue in tcf-tools env.
13mar14,wzc  support arm hpc(US17715)
*/

/*
DESCRIPTION
*/

#include <stdlib.h>
#include <string.h>

#include <hpc/hpc_drv/hpcHwDrvApi.h>
#include <hpc/drv_evt_cfg/hpcDrvEvtCfg.h>
#include <hpc/drv_evt_cfg/arm/armCtxA8EvtCfg.h>
#include <cafe/autogenerated/hpc_common.type.h>
#include <cafe/autogenerated/hpc_arm_ctxa8.type.h>

/* These events are from DDI0344K_cortex_a8_r3p2_trm.pdf */
struct armEventDescription hpcDrvEvtDescArmCtxA8[] = {
    {hpc_arm_cortex_a8_SW_INCR_VT_DEF, {10000}, {0x00, 0x7fffffff}},
    {hpc_level_1_instruction_cache_miss_VT_DEF, {10000}, {0x01, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1I_TLB_REFILL_VT_DEF, {10000}, {0x02, 0x7fffffff}},
    {hpc_level_1_data_cache_miss_VT_DEF, {10000}, {0x03, 0x7fffffff}},
    {hpc_level_1_data_cache_hit_VT_DEF, {10000}, {0x04, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1D_TLB_REFILL_VT_DEF, {10000}, {0x05, 0x7fffffff}},
    {hpc_load_instructions_VT_DEF, {50000}, {0x06, 0x7fffffff}},
    {hpc_store_instructions_VT_DEF, {50000}, {0x07, 0x7fffffff}},
    {hpc_total_instructions_VT_DEF, {100000}, {0x08, 0x7fffffff}},
    {hpc_interrupts_taken_VT_DEF, {1000}, {0x09, 0x7fffffff}},
    {hpc_arm_cortex_a8_EXC_EXECUTED_VT_DEF, {10000}, {0x0a, 0x7fffffff}},
    {hpc_arm_cortex_a8_CID_WRITE_VT_DEF, {10000}, {0x0b, 0x7fffffff}},
    {hpc_arm_cortex_a8_PC_WRITE_VT_DEF, {10000}, {0x0c, 0x7fffffff}},
    {hpc_arm_cortex_a8_PC_IMM_BRANCH_VT_DEF, {10000}, {0x0d, 0x7fffffff}},
    {hpc_arm_cortex_a8_PC_PROC_RETURN_VT_DEF, {10000}, {0x0e, 0x7fffffff}},
    {hpc_arm_cortex_a8_MEM_UNALIGNED_ACCESS_VT_DEF, {10000}, {0x0f, 0x7fffffff}},
    {hpc_arm_cortex_a8_PC_BRANCH_MIS_PRED_VT_DEF, {10000}, {0x10, 0x7fffffff}},
    {hpc_total_cycles_VT_DEF, {1000000}, {0x11, 0x80000000}},
    {hpc_arm_cortex_a8_PC_BRANCH_PRED_VT_DEF, {10000}, {0x12, 0x7fffffff}},
    {hpc_arm_cortex_a8_WRITE_BUFFER_CYCLE_VT_DEF, {10000}, {0x40, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_CACHE_ST_VT_DEF, {10000}, {0x41, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_CACHE_ST_TRANS_VT_DEF, {10000}, {0x42, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_CACHE_ACCESS_VT_DEF, {10000}, {0x43, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_CACHE_MISS_VT_DEF, {10000}, {0x44, 0x7fffffff}},
    {hpc_arm_cortex_a8_CYCLES_AXI_READ_VT_DEF, {10000}, {0x45, 0x7fffffff}},
    {hpc_arm_cortex_a8_CYCLES_AXI_WRITE_VT_DEF, {10000}, {0x46, 0x7fffffff}},
    {hpc_arm_cortex_a8_REPLAY_EVENTS_IN_MEM_VT_DEF, {10000}, {0x47, 0x7fffffff}},
    {hpc_arm_cortex_a8_UNALIGNED_MEM_ACCESS_VT_DEF, {10000}, {0x48, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1D_CACHE_MISS_VT_DEF, {10000}, {0x49, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1I_CACHE_MISS_VT_DEF, {10000}, {0x4a, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1D_PAGE_COLORING_ALIAS_VT_DEF, {10000}, {0x4b, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1D_NEON_HITS_VT_DEF, {10000}, {0x4c, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1D_NEON_ACCESS_VT_DEF, {10000}, {0x4d, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_NEON_ACCESS_VT_DEF, {10000}, {0x4e, 0x7fffffff}},
    {hpc_arm_cortex_a8_L2_NEON_HITS_VT_DEF, {10000}, {0x4f, 0x7fffffff}},
    {hpc_arm_cortex_a8_L1I_CACHE_VT_DEF, {10000}, {0x50, 0x7fffffff}},
    {hpc_arm_cortex_a8_RETRUN_STACK_NISPRE_VT_DEF, {10000}, {0x51, 0x7fffffff}},
    {hpc_arm_cortex_a8_BR_DIRECTION_MISPREDICTION_VT_DEF, {10000}, {0x52, 0x7fffffff}},
    {hpc_arm_cortex_a8_PREDICTABLE_BRANCH_VT_DEF, {10000}, {0x53, 0x7fffffff}},
    {hpc_arm_cortex_a8_PREDICTED_BRANCH_VT_DEF, {10000}, {0x54, 0x7fffffff}},
    {hpc_arm_cortex_a8_OPERATIONS_ISSUED_VT_DEF, {10000}, {0x55, 0x7fffffff}},
    {hpc_arm_cortex_a8_INCREMENT_NO_INSTRUCTIONS_VT_DEF, {10000}, {0x56, 0x7fffffff}},
    {hpc_arm_cortex_a8_INSTRUCTIONS_IN_CYCLE_VT_DEF, {10000}, {0x57, 0x7fffffff}},
    {hpc_arm_cortex_a8_CYCLES_STALL_AS_WAIT_DATA_VT_DEF, {10000}, {0x58, 0x7fffffff}},
    {hpc_arm_cortex_a8_CYCLES_STALL_AS_QUEUE_VT_DEF, {10000}, {0x59, 0x7fffffff}},
    {hpc_arm_cortex_a8_CYCLES_NEON_NOT_IDLE_VT_DEF, {10000}, {0x5a, 0x7fffffff}},
    {hpc_arm_cortex_a8_EVENTS_FROM_PMUEXTIN_0_VT_DEF, {10000}, {0x70, 0x7fffffff}},
    {hpc_arm_cortex_a8_EVENTS_FROM_PMUEXTIN_1_VT_DEF, {10000}, {0x71, 0x7fffffff}},
    {hpc_arm_cortex_a8_EVENTS_FROM_PMUEXTIN_0_1_VT_DEF, {10000}, {0x72, 0x7fffffff}},
};

const unsigned int hpcArmCtxA8NumEvents = CAFE_NELEMENTS(hpcDrvEvtDescArmCtxA8);

struct driverInstArm hpcHwDrvArmCtxA8 =
    {
    "Arm Device Common Events",
    0,
    0,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
    };
