/* Copyright (c) 2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
13mar14,wzc  support arm hpc(US17715)
*/

/*
DESCRIPTION
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <hpc/hpc_drv/hpcHwDrvApi.h>
#include <hpc/drv_evt_cfg/hpcDrvEvtCfg.h>
#include <hpc/hpc_drv/arm/armDrv.h>
#include <hpc/drv_evt_cfg/arm/armDrvSet.h>
#include <hpc/drv_evt_cfg/arm/armDrvEvtCfg.h>

#include "../../hpc_log.h"

int armEventSettingsGet
    (
    struct cafe_value_type * pType,
    union eventSettings * pDrvSettings,
    struct hpcEventSettings * pHpcSettings,
    const struct hpcEventDescriptor *pEvtDesc
    )
    {
    struct armEventDescription *armEvtDesc =
                  (struct armEventDescription *)pEvtDesc;
    
    if ((pDrvSettings == NULL) || (pHpcSettings == NULL) ||
        (pEvtDesc == NULL))
        return CAFE_ERROR;
    
    pDrvSettings->arm.evtCode = armEvtDesc->evtSettings.evtCode;
    pDrvSettings->arm.ctrMask = armEvtDesc->evtSettings.ctrMask;
    
    if (pHpcSettings->reload < armEvtDesc->hpcEventSettingsConst.reloadMin)
        pHpcSettings->reload = armEvtDesc->hpcEventSettingsConst.reloadMin;
    
    return CAFE_OK;
    }