/* Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

#include <stdlib.h>
#include <string.h>

#include <hpc/hpc_drv/hpcHwDrvApi.h>
#include <hpc/drv_evt_cfg/hpcDrvEvtCfg.h>
#include <hpc/hpc_drv/ppc/e500Drv.h>
#include <hpc/drv_evt_cfg/ppc/e500DrvEvtCfg.h>
#include <hpc/drv_evt_cfg/ppc/e500McCoreEvtCfg.h>
#include <cafe/autogenerated/hpc_common.type.h>
#include <cafe/autogenerated/hpc_e500mc.type.h>

#define NUM_COUNTERS		4
#define COUNTER_SIZE_MASK	0 /* All counters are 32-bit */

struct e500EventDescription hpcEvtDescE500Mc[] = {
    /* common named events */
    {hpc_total_cycles_VT_DEF,
	{500000},
	"Ref:1"},
    {hpc_total_instructions_VT_DEF,
	{500000},
	"Ref:2"},
    {hpc_load_instructions_VT_DEF,
	{50000},
	"Com:9"},
    {hpc_store_instructions_VT_DEF,
	{50000},
	"Com:10"},
    {hpc_level_1_data_cache_miss_VT_DEF,
	{1000},
	"Com:41"},
    {hpc_level_1_instruction_cache_miss_VT_DEF,
	{1000},
	"Com:60"},
    {hpc_compare_and_swap_successful_VT_DEF,
	{10000},
	"Com:179"},
    {hpc_compare_and_swap_unsuccessful_VT_DEF,
	{10000},
	"Com:180"},

    /* General Events */
    {hpc_e500mc_PROCESSOR_CYCLES_VT_DEF,
	{500000},
	"Ref:1"},
    {hpc_e500mc_INSTRUCTIONS_COMPLETED_VT_DEF,
	{500000},
	"Ref:2"},
    {hpc_e500mc_MICRO_OPS_COMPLETED_VT_DEF,
	{50000},
	"Com:3"},
    {hpc_e500mc_INSTRUCTIONS_FETCHED_VT_DEF,
	{500000},
	"Com:4"},
    {hpc_e500mc_MICRO_OPS_DECODED_VT_DEF,
	{500000},
	"Com:5"},
    {hpc_e500mc_PM_EVENT_TRANSITIONS_VT_DEF,
	{1000},
	"Com:6"},
    {hpc_e500mc_PM_EVENT_CYCLES_VT_DEF,
	{1000},
	"Com:7"},

    /* Instruction Types Completed */
    {hpc_e500mc_BRANCH_INSTRUCTIONS_COMPLETED_VT_DEF,
	{50000},
	"Com:8"},
    {hpc_e500mc_LOAD_MICRO_OPS_COMPLETED_VT_DEF,
	{20000},
	"Com:9"},
    {hpc_e500mc_STORE_MICRO_OPS_COMPLETED_VT_DEF,
	{20000},
	"Com:10"},
    {hpc_e500mc_NUMBER_OF_CQ_REDIRECTS_VT_DEF,
	{1000},
	"Com:11"},

    /* Branch Prediction and Execution Events */
    {hpc_e500mc_BRANCHES_FINISHED_VT_DEF,
	{1000},
	"Com:12"},
    {hpc_e500mc_TAKEN_BRANCHES_FINISHED_VT_DEF,
	{1000},
	"Com:13"},
    {hpc_e500mc_FINISHED_UNCONDITIONAL_BRANCHES_THAT_MISS_THE_BTB_VT_DEF,
	{1000},
	"Com:14"},
    {hpc_e500mc_BRANCHES_MISPREDICTED_VT_DEF,
	{1000},
	"Com:15"},
    {hpc_e500mc_BRANCHES_IN_THE_BTB_MISPREDICTED_DUE_TO_DIRECTION_PREDICTION_VT_DEF,
	{1000},
	"Com:16"},
    {hpc_e500mc_BTB_HITS_AND_PSEUDO_HITS_VT_DEF,
	{1000},
	"Com:17"},

    /* Pipeline Stalls */
    {hpc_e500mc_CYCLES_DECODE_STALLED_VT_DEF,
	{1000},
	"Com:18"},
    {hpc_e500mc_CYCLES_ISSUE_STALLED_VT_DEF,
	{1000},
	"Com:19"},
    {hpc_e500mc_CYCLES_BRANCH_ISSUE_STALLED_VT_DEF,
	{1000},
	"Com:20"},
    {hpc_e500mc_CYCLES_SFX0_SCHEDULE_STALLED_VT_DEF,
	{1000},
	"Com:21"},
    {hpc_e500mc_CYCLES_SFX1_SCHEDULE_STALLED_VT_DEF,
	{1000},
	"Com:22"},
    {hpc_e500mc_CYCLES_MU_SCHEDULE_STALLED_VT_DEF,
	{1000},
	"Com:23"},
    {hpc_e500mc_CYCLES_LRU_SCHEDULE_STALLED_VT_DEF,
	{1000},
	"Com:24"},
    {hpc_e500mc_CYCLES_BU_SCHEDULE_STALLED_VT_DEF,
	{1000},
	"Com:25"},

    /* Load/Store, Data Cache, and Data Line Fill Buffer (DLFB) Events */
    {hpc_e500mc_TOTAL_TRANSLATED_VT_DEF,
	{1000},
	"Com:26"},
    {hpc_e500mc_LOADS_TRANSLATED_VT_DEF,
	{1000},
	"Com:27"},
    {hpc_e500mc_STORES_TRANSLATED_VT_DEF,
	{1000},
	"Com:28"},
    {hpc_e500mc_TOUCHES_TRANSLATED_VT_DEF,
	{1000},
	"Com:29"},
    {hpc_e500mc_CACHEOPS_TRANSLATED_VT_DEF,
	{1000},
	"Com:30"},
    {hpc_e500mc_CACHE_INHIBITED_ACCESSES_TRANSLATED_VT_DEF,
	{1000},
	"Com:31"},
    {hpc_e500mc_GUARDED_LOADS_TRANSLATED_VT_DEF,
	{1000},
	"Com:32"},
    {hpc_e500mc_WRITE_THROUGH_STORES_TRANSLATED_VT_DEF,
	{1000},
	"Com:33"},
    {hpc_e500mc_MISALIGNED_LOAD_OR_STORE_ACCESSES_TRANSLATED_VT_DEF,
	{1000},
	"Com:34"},
    {hpc_e500mc_TOTAL_ALLOCATED_TO_DLFB_VT_DEF,
	{1000},
	"Com:35"},
    {hpc_e500mc_LOADS_TRANSLATED_AND_ALLOCATED_TO_DLFB_VT_DEF,
	{1000},
	"Com:36"},
    {hpc_e500mc_STORES_COMPLETED_AND_ALLOCATED_TO_DLFB_VT_DEF,
	{1000},
	"Com:37"},
    {hpc_e500mc_TOUCHES_TRANSLATED_AND_ALLOCATED_TO_DLFB_VT_DEF,
	{1000},
	"Com:38"},
    {hpc_e500mc_STORES_COMPLETED_VT_DEF,
	{1000},
	"Com:39"},
    {hpc_e500mc_DATA_L1_CACHE_LOCKS_VT_DEF,
	{1000},
	"Com:40"},
    {hpc_e500mc_DATA_L1_CACHE_RELOADS_VT_DEF,
	{1000},
	"Com:41"},
    {hpc_e500mc_DATA_L1_CACHE_CASTOUTS_VT_DEF,
	{1000},
	"Com:42"},

    /* Data Side Replay Conditions: Times Detected */
    {hpc_e500mc_LOAD_MISS_WITH_DLFB_FULL_TD_VT_DEF,
	{1000},
	"Com:43"},
    {hpc_e500mc_LOAD_MISS_WITH_LOAD_QUEUE_FULL_TD_VT_DEF,
	{1000},
	"Com:44"},
    {hpc_e500mc_LOAD_GUARDED_MISS_WHEN_THE_LOAD_IS_NOT_YET_AT_THE_BOTTOM_OF_THE_CQ_TD_VT_DEF,
	{1000},
	"Com:45"},
    {hpc_e500mc_TRANSLATE_A_STORE_WHEN_THE_STORE_QUEUE_IS_FULL_TD_VT_DEF,
	{1000},
	"Com:46"},
    {hpc_e500mc_ADDRESS_COLLISION_TD_VT_DEF,
	{1000},
	"Com:47"},
    {hpc_e500mc_DATA_MMU_MISS_TD_VT_DEF,
	{1000},
	"Com:48"},
    {hpc_e500mc_DATA_MMU_BUSY_TD_VT_DEF,
	{1000},
	"Com:49"},
    {hpc_e500mc_SECOND_PART_OF_MISALIGNED_ACCESS_WHEN_FIRST_PART_MISSED_IN_CACHE_TD_VT_DEF,
	{1000},
	"Com:50"},

    /* Data Side Replay Conditions: Cycles Stalled */
    {hpc_e500mc_LOAD_MISS_WITH_DLFB_FULL_CS_VT_DEF,
	{1000},
	"Com:51"},
    {hpc_e500mc_LOAD_MISS_WITH_LOAD_QUEUE_FULL_CS_VT_DEF,
	{1000},
	"Com:52"},
    {hpc_e500mc_LOAD_GUARDED_MISS_WHEN_THE_LOAD_IS_NOT_YET_AT_THE_BOTTOM_OF_THE_CQ_CS_VT_DEF,
	{1000},
	"Com:53"},
    {hpc_e500mc_TRANSLATE_A_STORE_WHEN_THE_STORE_QUEUE_IS_FULL_CS_VT_DEF,
	{1000},
	"Com:54"},
    {hpc_e500mc_ADDRESS_COLLISION_CS_VT_DEF,
	{1000},
	"Com:55"},
    {hpc_e500mc_DATA_MMU_MISS_CS_VT_DEF,
	{1000},
	"Com:56"},
    {hpc_e500mc_DATA_MMU_BUSY_CS_VT_DEF,
	{1000},
	"Com:57"},
    {hpc_e500mc_SECOND_PART_OF_MISALIGNED_ACCESS_WHEN_FIRST_PART_MISSED_IN_CACHE_CS_VT_DEF,
	{1000},
	"Com:58"},

    /* Fetch, Instruction Cache, Instruction Line Fill Buffer (ILFB), and Instruction Prefetch Events */
    {hpc_e500mc_INSTRUCTION_L1_CACHE_LOCKS_VT_DEF,
	{1000},
	"Com:59"},
    {hpc_e500mc_INSTRUCTION_L1_CACHE_RELOADS_FROM_FETCH_VT_DEF,
	{1000},
	"Com:60"},
    {hpc_e500mc_NUMBER_OF_FETCHES_VT_DEF,
	{1000},
	"Com:61"},
    {hpc_e500mc_INSTRUCTION_MMU_TLB4K_RELOADS_VT_DEF,
	{1000},
	"Com:62"},
    {hpc_e500mc_INSTRUCTION_MMU_VSP_RELOADS_VT_DEF,
	{1000},
	"Com:63"},
    {hpc_e500mc_DATA_MMU_TLB4K_RELOADS_VT_DEF,
	{1000},
	"Com:64"},
    {hpc_e500mc_DATA_MMU_VSP_RELOADS_VT_DEF,
	{1000},
	"Com:65"},
    {hpc_e500mc_L2_MMU_MISSES_VT_DEF,
	{1000},
	"Com:66"},

    /* BIU Interface Usage */
    {hpc_e500mc_BIU_MASTER_REQUESTS_VT_DEF,
	{1000},
	"Com:67"},
    {hpc_e500mc_BIU_MASTER_INSTRUCTION_SIDE_REQUESTS_VT_DEF,
	{1000},
	"Com:68"},
    {hpc_e500mc_BIU_MASTER_DATA_SIDE_REQUESTS_VT_DEF,
	{1000},
	"Com:69"},
    {hpc_e500mc_BIU_MASTER_DATA_SIDE_CASTOUT_REQUESTS_VT_DEF,
	{1000},
	"Com:70"},

    /* Snoop */
    {hpc_e500mc_SNOOP_REQUESTS_VT_DEF,
	{1000},
	"Com:72"},
    {hpc_e500mc_SNOOP_HITS_VT_DEF,
	{1000},
	"Com:73"},
    {hpc_e500mc_SNOOP_PUSHES_VT_DEF,
	{1000},
	"Com:74"},
#if 0
    /* Threshold Events (not supported) */
    {hpc_e500mc_DATA_LINE_FILL_BUFFER_LOAD_MISS_CYCLES_VT_DEF,
	{1000},
	"C0,1:76"},
    {hpc_e500mc_ILFB_FETCH_MISS_CYCLES_VT_DEF,
	{1000},
	"C0,1,:77"},
    {hpc_e500mc_EXTERNAL_INPUT_INTERRUPT_LATENCY_CYCLES_VT_DEF,
	{1000},
	"C0,1:78"},
    {hpc_e500mc_CRITICAL_INPUT_INTERRUPT_LATENCY_CYCLES_VT_DEF,
	{1000},
	"C0,1,:79"},
    {hpc_e500mc_EXTERNAL_INPUT_INTERRUPT_PENDING_LATENCY_CYCLES_VT_DEF,
	{1000},
	"C0,1,:80"},
    {hpc_e500mc_CRITICAL_INPUT_INTERRUPT_PENDING_LATENCY_CYCLES_VT_DEF,
	{1000},
	"C0,1,:81"},

    /* Chaining Events (not supported) */
    {hpc_e500mc_PMC0_OVERFLOW_VT_DEF,
	{1000},
	"Com:82"},
    {hpc_e500mc_PMC1_OVERFLOW_VT_DEF,
	{1000},
	"Com:83"},
    {hpc_e500mc_PMC2_OVERFLOW_VT_DEF,
	{1000},
	"Com:84"},
    {hpc_e500mc_PMC3_OVERFLOW_VT_DEF,
	{1000},
	"Com:85"},
#endif
    /* Interrupt Events */
    {hpc_e500mc_INTERRUPTS_TAKEN_VT_DEF,
	{1000},
	"Com:86"},
    {hpc_e500mc_EXTERNAL_INPUT_INTERRUPTS_TAKEN_VT_DEF,
	{1000},
	"Com:87"},
    {hpc_e500mc_CRITICAL_INPUT_INTERRUPTS_TAKEN_VT_DEF,
	{1000},
	"Com:88"},
    {hpc_e500mc_SYSTEM_CALL_AND_TRAP_INTERRUPTS_VT_DEF,
	{1000},
	"Com:89"},

    /* Misc Events */
    {hpc_e500mc_TRANSITIONS_OF_TBL_BIT_SELECTED_BY_PMGC0_TBSEL_VT_DEF,
	{1000},
	"Com:90"},
    {hpc_e500mc_L2_LINEFILL_BUFFER_VT_DEF,
	{1000},
	"Com:91"},
    {hpc_e500mc_L2_VS_VT_DEF,
	{1000},
	"Com:92"},
    {hpc_e500mc_CASTOUTS_RELEASED_VT_DEF,
	{1000},
	"Com:93"},
    {hpc_e500mc_INTV_ALLOCATIONS_VT_DEF,
	{1000},
	"Com:94"},
    {hpc_e500mc_STORE_RETRIES_TO_MBAR_VT_DEF,
	{1000},
	"Com:95"},
    {hpc_e500mc_STORE_RETRIES_DUE_TO_MISC_VT_DEF,
	{1000},
	"Com:96"},

    /* Stashing Events */
    {hpc_e500mc_STASH_L1_HIT_VT_DEF,
	{1000},
	"Com:97"},
    {hpc_e500mc_STASH_L2_HIT_VT_DEF,
	{1000},
	"Com:98"},
    {hpc_e500mc_STASH_BUSY_1_VT_DEF,
	{1000},
	"Com:99"},
    {hpc_e500mc_STASH_BUSY_2_VT_DEF,
	{1000},
	"Com:100"},
    {hpc_e500mc_STASH_BUSY_3_VT_DEF,
	{1000},
	"Com:101"},
    {hpc_e500mc_STASH_HIT_VT_DEF,
	{1000},
	"Com:102"},
    {hpc_e500mc_STASH_HIT_DLFB_VT_DEF,
	{1000},
	"Com:103"},
    {hpc_e500mc_STASH_DOWNGRADE_1_VT_DEF,
	{1000},
	"Com:104"},
    {hpc_e500mc_STASH_DOWNGRADE_2_VT_DEF,
	{1000},
	"Com:105"},
    {hpc_e500mc_STASH_REQUESTS_VT_DEF,
	{1000},
	"Com:106"},
    {hpc_e500mc_STASHES_TO_L1_DATA_CACHE_VT_DEF,
	{1000},
	"Com:107"},
    {hpc_e500mc_STASHES_TO_BACKSIDE_L2_VT_DEF,
	{1000},
	"Com:108"},
    {hpc_e500mc_STALLS_DUE_TO_NO_CAQ_OR_COB_VT_DEF,
	{1000},
	"Com:109"},

    /* Backside L2 Events */
    {hpc_e500mc_L2_CACHE_ACCESSES_VT_DEF,
	{1000},
	"Com:110"},
    {hpc_e500mc_L2_HIT_CACHE_ACCESSES_VT_DEF,
	{1000},
	"Com:111"},
    {hpc_e500mc_L2_CACHE_DATA_ACCESSES_VT_DEF,
	{1000},
	"Com:112"},
    {hpc_e500mc_L2_CACHE_DATA_HITS_VT_DEF,
	{1000},
	"Com:113"},
    {hpc_e500mc_L2_CACHE_INSTRUCTION_ACCESSES_VT_DEF,
	{1000},
	"Com:114"},
    {hpc_e500mc_L2_CACHE_INSTRUCTION_HITS_VT_DEF,
	{1000},
	"Com:115"},
    {hpc_e500mc_L2_CACHE_ALLOCATIONS_VT_DEF,
	{1000},
	"Com:116"},
    {hpc_e500mc_L2_CACHE_DATA_ALLOCATIONS_VT_DEF,
	{1000},
	"Com:117"},
    {hpc_e500mc_L2_CACHE_DIRTY_DATA_ALLOCATIONS_VT_DEF,
	{1000},
	"Com:118"},
    {hpc_e500mc_L2_CACHE_INSTRUCTION_ALLOCATIONS_VT_DEF,
	{1000},
	"Com:119"},
    {hpc_e500mc_L2_CACHE_UPDATES_VT_DEF,
	{1000},
	"Com:120"},
    {hpc_e500mc_L2_CACHE_CLEAN_UPDATES_VT_DEF,
	{1000},
	"Com:121"},
    {hpc_e500mc_L2_CACHE_DIRTY_UPDATES_VT_DEF,
	{1000},
	"Com:122"},
    {hpc_e500mc_L2_CACHE_CLEAN_REDUNDANT_UPDATES_VT_DEF,
	{1000},
	"Com:123"},
    {hpc_e500mc_L2_CACHE_DIRTY_REDUNDANT_UPDATES_VT_DEF,
	{1000},
	"Com:124"},
    {hpc_e500mc_L2_CACHE_LOCKS_VT_DEF,
	{1000},
	"Com:125"},
    {hpc_e500mc_L2_CACHE_CASTOUTS_VT_DEF,
	{1000},
	"Com:126"},
    {hpc_e500mc_L2_CACHE_DATA_DIRTY_HITS_VT_DEF,
	{1000},
	"Com:127"},
    {hpc_e500mc_INSTRUCTION_LFB_WENT_HIGH_PRIORITY_VT_DEF,
	{1000},
	"Com:128"},
    {hpc_e500mc_SNOOP_THROTTLING_TURNED_ON_VT_DEF,
	{1000},
	"Com:129"},
    {hpc_e500mc_L2_INVALIDATION_OF_CLEAN_LINES_VT_DEF,
	{1000},
	"Com:130"},
    {hpc_e500mc_L2_INVALIDATION_OF_INCOHERENT_LINE_VT_DEF,
	{1000},
	"Com:131"},
    {hpc_e500mc_L2_INVALIDATION_OF_COHERENT_LINE_VT_DEF,
	{1000},
	"Com:132"},
    {hpc_e500mc_COHERENT_LOOKUP_MISS_DUE_TO_VALID_BUT_INCOHERENT_ADDRESS_MATCHES_VT_DEF,
	{1000},
	"Com:133"},

    /* IAC, DAC Events */
    {hpc_e500mc_IAC1S_DETECTED_VT_DEF,
	{1000},
	"Com:140"},
    {hpc_e500mc_IAC2S_DETECTED_VT_DEF,
	{1000},
	"Com:141"},
    {hpc_e500mc_DAC1S_DETECTED_VT_DEF,
	{1000},
	"Com:144"},
    {hpc_e500mc_DAC2S_DETECTED_VT_DEF,
	{1000},
	"Com:145"},

    /* DVT Events */
    {hpc_e500mc_DVT0_DETECTED_VT_DEF,
	{1000},
	"Com:148"},
    {hpc_e500mc_DVT1_DETECTED_VT_DEF,
	{1000},
	"Com:149"},
    {hpc_e500mc_DVT2_DETECTED_VT_DEF,
	{1000},
	"Com:150"},
    {hpc_e500mc_DVT3_DETECTED_VT_DEF,
	{1000},
	"Com:151"},
    {hpc_e500mc_DVT4_DETECTED_VT_DEF,
	{1000},
	"Com:150"},
    {hpc_e500mc_DVT5_DETECTED_VT_DEF,
	{1000},
	"Com:153"},
    {hpc_e500mc_DVT6_DETECTED_VT_DEF,
	{1000},
	"Com:154"},
    {hpc_e500mc_DVT7_DETECTED_VT_DEF,
	{1000},
	"Com:155"},
    {hpc_e500mc_CYCLES_COMPLETION_STALLED_NEXUS_VT_DEF,
	{1000},
	"Com:156"},

    /* FPU Events */
    {hpc_e500mc_FPU_DOUBLE_PUMP_VT_DEF,
	{1000},
	"Com:160"},
    {hpc_e500mc_FPU_FINISH_VT_DEF,
	{1000},
	"Com:161"},
    {hpc_e500mc_FPU_DIVIDE_CYCLES_VT_DEF,
	{1000},
	"Com:162"},
    {hpc_e500mc_FPU_DENORM_INPUT_VT_DEF,
	{1000},
	"Com:163"},
    {hpc_e500mc_FPU_RESULT_STALL_VT_DEF,
	{1000},
	"Com:164"},
    {hpc_e500mc_FPU_FPSCR_FULL_STALL_VT_DEF,
	{1000},
	"Com:165"},
    {hpc_e500mc_FPU_PIPE_SYNC_STALL_VT_DEF,
	{1000},
	"Com:166"},
    {hpc_e500mc_FPU_INPUT_DATA_STALL_VT_DEF,
	{1000},
	"Com:167"},

    /* Extended Load Store Events */
    {hpc_e500mc_DECORATED_LOADS_VT_DEF,
	{1000},
	"Com:176"},
    {hpc_e500mc_DECORATED_STORES_VT_DEF,
	{1000},
	"Com:177"},
    {hpc_e500mc_LOAD_RETRIES_VT_DEF,
	{1000},
	"Com:178"},
    {hpc_e500mc_STWCX_SUCCESSES_VT_DEF,
	{1000},
	"Com:179"},
    {hpc_e500mc_STWCX_UNSUCCESSFUL_VT_DEF,
	{1000},
	"Com:180"}};

const unsigned int hpcE500McNumEvents = CAFE_NELEMENTS(hpcEvtDescE500Mc);

/******************************************************************************
*/

struct driverInstE500 hpcHwDrvE500McCore =
    {
    "e500mc Core Events",
    0,
    NUM_COUNTERS,
    COUNTER_SIZE_MASK,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
    };
