/* Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

#include <stdlib.h>
#include <string.h>

#include <hpc/hpc_drv/hpcHwDrvApi.h>
#include <hpc/drv_evt_cfg/hpcDrvEvtCfg.h>
#include <hpc/hpc_drv/ppc/e500Drv.h>
#include <hpc/drv_evt_cfg/ppc/e500DrvEvtCfg.h>
#include <hpc/drv_evt_cfg/ppc/fslP2020EvtCfg.h>
#include <cafe/autogenerated/hpc_common.type.h>
#include <cafe/autogenerated/hpc_p2020.type.h>

#define NUM_COUNTERS      12
#define COUNTER_SIZE_MASK 0x1 /* PMC0 64bit, PMC1-PMC11 are 32bit */

struct e500EventDescription hpcDrvEvtDescFslP2020[] = {
    /* common named events */
    {hpc_level_2_instruction_cache_hit_VT_DEF,
	{1000},
	"C2:123"},
    {hpc_level_2_instruction_cache_miss_VT_DEF,
	{1000},
	"Ref1:23"},
    {hpc_level_2_data_cache_hit_VT_DEF,
	{1000},
	"C4:121"},
    {hpc_level_2_data_cache_miss_VT_DEF,
	{1000},
	"C5:115"},

    /* hw specific named events */

    /* General Events */
    {hpc_qoriq_p2020_SYSTEM_CYCLES_VT_DEF,
	{500000}, "C0:0"},
    {hpc_qoriq_p2020_SYSTEM_CYCLES_EVENT2_VT_DEF,
	{500000}, "Ref1:63"},

    /* DDR Memory Controller Events */
    {hpc_qoriq_p2020_CYCLES_A_READ_IS_RETURNING_DATA_FROM_DRAM_VT_DEF,
	{1000},	"Ref1:19"},
    {hpc_qoriq_p2020_CYCLES_A_READ_OR_WRITE_TRANSFERS_DATA_FROM_OR_TO_DRAM_VT_DEF,
	{1000},	"Ref1:27"},
    {hpc_qoriq_p2020_PIPELINED_READ_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C1:121"},
    {hpc_qoriq_p2020_PIPELINED_READ_OR_WRITE_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C2:64"},
    {hpc_qoriq_p2020_NON_PIPELINED_READ_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C3:124"},
    {hpc_qoriq_p2020_NON_PIPELINED_READ_OR_WRITE_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C4:64"},
    {hpc_qoriq_p2020_PIPELINED_READ_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C5:120"},
    {hpc_qoriq_p2020_PIPELINED_READ_OR_WRITE_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C6:64"},
    {hpc_qoriq_p2020_NON_PIPELINED_READ_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C7:121"},
    {hpc_qoriq_p2020_NON_PIPELINED_READ_OR_WRITE_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000},	"C8:64"},
    {hpc_qoriq_p2020_FORCED_PAGE_CLOSINGS_NOT_CAUSED_BY_A_REFRESH_VT_DEF,
	{1000},	"C1:64"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_MISSES_VT_DEF,
	{1000},	"C2:65"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_MISSES_EVENT2_VT_DEF,
	{1000},	"C11:66"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_VT_DEF,
	{1000},	"C3:64"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_EVENT2_VT_DEF,
	{1000},	"C10:68"},
    {hpc_qoriq_p2020_FORCE_PAGE_CLOSINGS_VT_DEF,
	{1000},	"C4:65"},
    {hpc_qoriq_p2020_READ_MODIFY_WRITE_TRANSACTIONS_DUE_TO_ECC_VT_DEF,
	{1000},	"C5:64"},
    {hpc_qoriq_p2020_FORCED_PAGE_CLOSINGS_DUE_TO_COLLISION_WITH_BANK_AND_SUB_BANK_VT_DEF,
	{1000},	"C9:64"},
    {hpc_qoriq_p2020_READS_OR_WRITES_FROM_CORE_0_1_VT_DEF,
	{1000},	"Ref1:13"},
    {hpc_qoriq_p2020_READS_OR_WRITES_FROM_ETSEC_1_3_VT_DEF,
	{1000},	"C3:65"},
    {hpc_qoriq_p2020_READS_OR_WRITES_FROM_HIGH_SPEED_INTERFACES_VT_DEF,
	{1000},	"C4:67"},
    {hpc_qoriq_p2020_READS_OR_WRITES_FROM_DMA_1_2_VT_DEF,
	{1000},	"C5:66"},
    {hpc_qoriq_p2020_READS_OR_WRITES_FROM_SECURITY_VT_DEF,
	{1000},	"C6:69"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_CORE_0_1_VT_DEF,
	{1000},	"Ref1:14"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_ETSEC_1_4_VT_DEF,
	{1000},	"C6:65"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_HIGH_SPEED_INTERFACES_VT_DEF,
	{1000},	"C7:65"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_DMA_1_2_VT_DEF,
	{1000},	"C8:66"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_SECURITY_VT_DEF,
	{1000},	"C7:68"},
    {hpc_qoriq_p2020_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_SECURITY_EVENT2_VT_DEF,
	{1000},	"C10:65"},

    /* Memory Target Queue 1 Events */

    /* DMA Controller 1 Events */
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_READ_REQUEST_VT_DEF,
	{1000},	"C1:66"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_READ_REQUEST_VT_DEF,
	{1000},	"C2:69"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_READ_REQUEST_VT_DEF,
	{1000},	"C3:68"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_READ_REQUEST_VT_DEF,
	{1000},	"C4:70"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_WRITE_REQUEST_VT_DEF,
	{1000},	"C1:67"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_WRITE_REQUEST_VT_DEF,
	{1000},	"C2:70"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_WRITE_REQUEST_VT_DEF,
	{1000},	"C3:69"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_WRITE_REQUEST_VT_DEF,
	{1000},	"C4:71"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C5:105"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C6:108"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C7:105"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C8:105"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C1:68"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C5:117"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C2:71"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C6:122"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C3:70"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C7:118"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C4:72"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C8:116"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_0_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C1:69"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_1_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C2:72"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_2_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C3:71"},
    {hpc_qoriq_p2020_DMA1_CHANNEL_3_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C4:73"},

    /* DMA Controller 2 Events */
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_READ_REQUEST_VT_DEF,
	{1000},	"C8:86"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_READ_REQUEST_VT_DEF,
	{1000},	"C5:94"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_READ_REQUEST_VT_DEF,
	{1000},	"C10:75"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_READ_REQUEST_VT_DEF,
	{1000},	"C11:73"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_WRITE_REQUEST_VT_DEF,
	{1000},	"C8:90"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_WRITE_REQUEST_VT_DEF,
	{1000},	"C5:104"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_WRITE_REQUEST_VT_DEF,
	{1000},	"C10:76"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_WRITE_REQUEST_VT_DEF,
	{1000},	"C11:74"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C4:101"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C5:85"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C6:79"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_DESCRIPTOR_REQUEST_VT_DEF,
	{1000},	"C7:91"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C1:78"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C8:91"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C2:80"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C9:108"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C3:82"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C10:77"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_READ_DW_OR_LESS_VT_DEF,
	{1000},	"C4:107"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000},	"C11:75"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_0_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C5:95"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_1_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C6:92"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_2_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C7:92"},
    {hpc_qoriq_p2020_DMA2_CHANNEL_3_WRITE_DW_OR_LESS_VT_DEF,
	{1000},	"C8:92"},

    /* e500 Coherency Module (ECM) Events */
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_CORE_0_VT_DEF,
	{1000},	"C8:77"},
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_CORE_1_VT_DEF,
	{1000},	"C11:98"},
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_I2C_SECURITY_TEST_PORT_VT_DEF,
	{1000},	"C7:77"},
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_PEX1_3_DMA1_2_SRIO1_2_VT_DEF,
	{1000},	"C5:80"},
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_ETSEC1_3_VT_DEF,
	{1000},	"C6:80"},
    {hpc_qoriq_p2020_ECM_REQUEST_WAIT_SAP_USB_ESDHC_VT_DEF,
	{1000},	"C4:84"},
    {hpc_qoriq_p2020_ECM_DISPATCH_VT_DEF,
	{1000},	"Ref1:15"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_CORE_0_VT_DEF,
	{1000},	"C1:80"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_CORE_1_VT_DEF,
	{1000},	"C10:95"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_ETSEC1_VT_DEF,
	{1000},	"C4:85"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_ETSEC2_VT_DEF,
	{1000},	"C8:80"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_ETSEC3_VT_DEF,
	{1000},	"C9:80"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_SRIO1_VT_DEF,
	{1000},	"C10:96"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_SRIO2_VT_DEF,
	{1000},	"C11:65"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_PEX1_VT_DEF,
	{1000},	"C8:81"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_PEX2_VT_DEF,
	{1000},	"C10:98"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_PEX3_VT_DEF,
	{1000},	"C7:78"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_DMA1_VT_DEF,
	{1000},	"C9:82"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_DMA2_VT_DEF,
	{1000},	"C10:99"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_SECURITY_VT_DEF,
	{1000},	"C10:100"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_RIO_MESSAGE_UNIT_DOOR_BELL_OR_PORT_WRITE_VT_DEF,
	{1000},	"C8:78"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_USB_HOST_VT_DEF,
	{1000},	"C10:66"},
    {hpc_qoriq_p2020_ECM_DISPATCH_FROM_USB_DUAL_ROLE_VT_DEF,
	{1000},	"C9:68"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_DDR_VT_DEF,
	{1000},	"C7:79"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_L2_VT_DEF,
	{1000},	"C10:102"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_SRAM_VT_DEF,
	{1000},	"C8:79"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_LBC_VT_DEF,
	{1000},	"C9:83"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_SRIO1_VT_DEF,
	{1000},	"C1:85"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_SRIO2_VT_DEF,
	{1000},	"C11:67"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_PEX1_VT_DEF,
	{1000},	"C2:84"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_PEX2_VT_DEF,
	{1000},	"C1:81"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_PEX3_VT_DEF,
	{1000},	"C2:85"},
    {hpc_qoriq_p2020_ECM_DISPATCH_TO_CCSR_VT_DEF,
	{1000},	"C9:87"},
    {hpc_qoriq_p2020_ECM_DISPATCH_WRITE_VT_DEF,
	{1000},	"C7:81"},
    {hpc_qoriq_p2020_ECM_DISPATCH_WRITE_ALLOCATE_VT_DEF,
	{1000},	"C1:82"},
    {hpc_qoriq_p2020_ECM_DISPATCH_READ_VT_DEF,
	{1000},	"C2:86"},
    {hpc_qoriq_p2020_ECM_DISPATCH_READ_ATOMIC_VT_DEF,
	{1000},	"C3:86"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_DDR_VT_DEF,
	{1000},	"C1:83"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_I2C_SECURITY_TEST_PORT_VT_DEF,
	{1000},	"C3:87"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_PEX1_3_DMA1_2_SRIO1_2_VT_DEF,
	{1000},	"C4:89"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_LBC_VT_DEF,
	{1000},	"Ref1:16"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_ETSEC1_3_VT_DEF,
	{1000},	"Ref1:17"},
    {hpc_qoriq_p2020_ECM_DATA_BUS_GRANT_SAP_USB_ESDHC_VT_DEF,
	{1000},	"Ref1:18"},
    {hpc_qoriq_p2020_ECM_GLOBAL_DATA_BUS_BEAT_VT_DEF,
	{1000},	"C5:86"},

    /* I2C/Security Events */
    {hpc_qoriq_p2020_I2C_SECURITY_REQUESTS_VT_DEF,
	{1000},	"C1:119"},
    {hpc_qoriq_p2020_I2C_SECURITY_READ_REQUESTS_VT_DEF,
	{1000},	"C2:76"},
    {hpc_qoriq_p2020_I2C_SECURITY_DATA_BEATS_VT_DEF,
	{1000},	"C3:75"},
    {hpc_qoriq_p2020_I2C_SECURITY_READ_DATA_BEATS_VT_DEF,
	{1000},	"C4:79"},
    {hpc_qoriq_p2020_I2C_SECURITY_REQUEST_LESS_THAN_32_BYTES_VT_DEF,
	{1000},	"C7:76"},

    /* USB/eSDHC Events */
    {hpc_qoriq_p2020_USB_ESDHC_REQUESTS_VT_DEF,
	{1000},	"C1:99"},
    {hpc_qoriq_p2020_USB_ESDHC_READ_REQUESTS_VT_DEF,
	{1000},	"C10:78"},
    {hpc_qoriq_p2020_USB_ESDHC_DATA_BEATS_VT_DEF,
	{1000},	"C11:76"},
    {hpc_qoriq_p2020_USB_ESDHC_READ_DATA_BEATS_VT_DEF,
	{1000},	"C5:96"},
    {hpc_qoriq_p2020_USB_ESDHC_REQUEST_LESS_THAN_32_BYTES_VT_DEF,
	{1000},	"C3:101"},

    /* Interrupt Controller (PIC) Events */
    {hpc_qoriq_p2020_PIC_TOTAL_INTERRUPT_COUNT_VT_DEF,
	{1000},	"Ref1:26"},
    {hpc_qoriq_p2020_PIC_INTERRUPT_WAIT_CYCLES_VT_DEF,
	{1000},	"C8:126"},
    {hpc_qoriq_p2020_PIC_INTERRUPT_SERVICE_CYCLES_VT_DEF,
	{1000},	"C2:83"},
#if 0
    /* Threshold events are not supported */
    {hpc_qoriq_p2020_PIC_INTERRUPT_SELECT_0_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C1:120"},
    {hpc_qoriq_p2020_PIC_INTERRUPT_SELECT_1_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C3:123"},
    {hpc_qoriq_p2020_PIC_INTERRUPT_SELECT_2_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C5:119"},
    {hpc_qoriq_p2020_PIC_INTERRUPT_SELECT_3_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C6:124"},
#endif
    /* eTSEC 1 Events */
    {hpc_qoriq_p2020_ETSEC1_DMA_WRITE_DATA_BEATS_VT_DEF,
	{1000},	"C3:109"},
    {hpc_qoriq_p2020_ETSEC1_DMA_READ_DATA_BEATS_VT_DEF,
	{1000},	"C4:110"},
    {hpc_qoriq_p2020_ETSEC1_DMA_WRITE_REQUEST_VT_DEF,
	{1000},	"C5:106"},
    {hpc_qoriq_p2020_ETSEC1_DMA_READ_REQUEST_VT_DEF,
	{1000},	"C6:109"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_DROPPED_FRAMES_VT_DEF,
	{1000},	"C9:88"},
    {hpc_qoriq_p2020_ETSEC1_TXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:34"},
    {hpc_qoriq_p2020_ETSEC1_RXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:38"},
    {hpc_qoriq_p2020_ETSEC1_TXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:42"},
    {hpc_qoriq_p2020_ETSEC1_RXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:46"},
    {hpc_qoriq_p2020_ETSEC1_READ_DATA_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:50"},
    {hpc_qoriq_p2020_ETSEC1_RX_IP_PACKETS_CHECKED_FOR_CHECKSUM_VT_DEF,
	{1000},	"C9:92"},
    {hpc_qoriq_p2020_ETSEC1_TX_IP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C1:105"},
    {hpc_qoriq_p2020_ETSEC1_TX_TCP_UDP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C2:113"},
    {hpc_qoriq_p2020_ETSEC1_TCP_UDP_PACKETS_CHECKED_FOR_CS_VT_DEF,
	{1000},	"C3:114"},
    {hpc_qoriq_p2020_ETSEC1_IP_OR_TCP_UDP_RX_CHECKSUM_ERROR_VT_DEF,
	{1000},	"C4:115"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_REJECTED_FRAMES_BY_FILER_VT_DEF,
	{1000},	"C5:111"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_REJECTED_FRAMES_DUE_TO_FILER_ERROR_VT_DEF,
	{1000},	"C6:114"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_CYCLES_RX_FIFO_GT_1_4_FULL_VT_DEF,
	{1000},	"C5:110"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_CYCLES_RX_FIFO_GT_1_2_FULL_VT_DEF,
	{1000},	"C6:113"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_CYCLES_RX_FIFO_GT_3_4_FULL_VT_DEF,
	{1000},	"C7:110"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_CYCLES_RX_FIFO_EQ_FULL_VT_DEF,
	{1000},	"C8:110"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_ACCEPTED_FRAMES_MATCH_VT_DEF,
	{1000},	"C9:110"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_ACCEPTED_FRAMS_TO_STATION_ADDRESS_VT_DEF,
	{1000},	"C10:80"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_ACCEPTED_UNICASET_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C11:78"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_ACCEPTED_GROUP_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C6:96"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_ACCEPTED_FRAMS_VIA_EXACT_MATCH_VT_DEF,
	{1000},	"C7:100"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_REJECTED_FRAMES_AT_LAYER_2_VT_DEF,
	{1000},	"C9:111"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_RX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C8:94"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_TX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C9:112"},
    {hpc_qoriq_p2020_ETSEC1_RX_DATA_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C10:81"},
    {hpc_qoriq_p2020_ETSEC1_NUMBER_OF_RX_PACKETS_RECEIVED_WHILE_RX_FIFO_IS_FULL_VT_DEF,
	{1000},	"C11:79"},

    /* eTSEC 2 Events */
    {hpc_qoriq_p2020_ETSEC2_DMA_WRITE_DATA_BEATS_VT_DEF,
	{1000},	"C5:107"},
    {hpc_qoriq_p2020_ETSEC2_DMA_READ_DATA_BEATS_VT_DEF,
	{1000},	"C6:110"},
    {hpc_qoriq_p2020_ETSEC2_DMA_WRITE_REQUEST_VT_DEF,
	{1000},	"C7:107"},
    {hpc_qoriq_p2020_ETSEC2_DMA_READ_REQUEST_VT_DEF,
	{1000},	"C8:107"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_DROPPED_FRAMES_VT_DEF,
	{1000},	"C2:110"},
    {hpc_qoriq_p2020_ETSEC2_TXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:35"},
    {hpc_qoriq_p2020_ETSEC2_RXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:39"},
    {hpc_qoriq_p2020_ETSEC2_TXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:43"},
    {hpc_qoriq_p2020_ETSEC2_RXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:47"},
    {hpc_qoriq_p2020_ETSEC2_READ_DATA_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:51"},
    {hpc_qoriq_p2020_ETSEC2_RX_IP_PACKETS_CHECKED_FOR_CHECKSUM_VT_DEF,
	{1000},	"C3:115"},
    {hpc_qoriq_p2020_ETSEC2_TX_IP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C4:116"},
    {hpc_qoriq_p2020_ETSEC2_TX_TCP_UDP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C5:101"},
    {hpc_qoriq_p2020_ETSEC2_TCP_UDP_PACKETS_CHECKED_FOR_CS_VT_DEF,
	{1000},	"C6:115"},
    {hpc_qoriq_p2020_ETSEC2_IP_OR_TCP_UDP_RX_CHECKSUM_ERROR_VT_DEF,
	{1000},	"C7:111"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_REJECTED_FRAMES_BY_FILER_VT_DEF,
	{1000},	"C8:111"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_REJECTED_FRAMES_DUE_TO_FILER_ERROR_VT_DEF,
	{1000},	"C9:93"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_CYCLES_RX_FIFO_GT_1_4_FULL_VT_DEF,
	{1000},	"C7:113"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_CYCLES_RX_FIFO_GT_1_2_FULL_VT_DEF,
	{1000},	"C8:113"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_CYCLES_RX_FIFO_GT_3_4_FULL_VT_DEF,
	{1000},	"C9:96"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_CYCLES_RX_FIFO_EQ_FULL_VT_DEF,
	{1000},	"C1:108"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_ACCEPTED_FRAMES_MATCH_VT_DEF,
	{1000},	"C9:113"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_ACCEPTED_FRAMS_TO_STATION_ADDRESS_VT_DEF,
	{1000},	"C10:82"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_ACCEPTED_UNICASET_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C11:80"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_ACCEPTED_GROUP_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C6:97"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_ACCEPTED_FRAMS_VIA_EXACT_MATCH_VT_DEF,
	{1000},	"C7:101"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_REJECTED_FRAMES_AT_LAYER_2_VT_DEF,
	{1000},	"C9:114"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_RX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C10:83"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_TX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C11:81"},
    {hpc_qoriq_p2020_ETSEC2_RX_DATA_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C8:96"},
    {hpc_qoriq_p2020_ETSEC2_NUMBER_OF_RX_PACKETS_RECEIVED_WHILE_RX_FIFO_IS_FULL_VT_DEF,
	{1000},	"C9:115"},

    /* eTSEC 3 Events */
    {hpc_qoriq_p2020_ETSEC3_DMA_WRITE_DATA_BEATS_VT_DEF,
	{1000},	"C7:108"},
    {hpc_qoriq_p2020_ETSEC3_DMA_READ_DATA_BEATS_VT_DEF,
	{1000},	"C8:108"},
    {hpc_qoriq_p2020_ETSEC3_DMA_WRITE_REQUEST_VT_DEF,
	{1000},	"C9:90"},
    {hpc_qoriq_p2020_ETSEC3_DMA_READ_REQUEST_VT_DEF,
	{1000},	"C1:103"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_DROPPED_FRAMES_VT_DEF,
	{1000},	"C4:112"},
    {hpc_qoriq_p2020_ETSEC3_TXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:36"},
    {hpc_qoriq_p2020_ETSEC3_RXBD_READ_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:40"},
    {hpc_qoriq_p2020_ETSEC3_TXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:44"},
    {hpc_qoriq_p2020_ETSEC3_RXBD_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:48"},
    {hpc_qoriq_p2020_ETSEC3_READ_DATA_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:52"},
    {hpc_qoriq_p2020_ETSEC3_RX_IP_PACKETS_CHECKED_FOR_CHECKSUM_VT_DEF,
	{1000},	"C6:116"},
    {hpc_qoriq_p2020_ETSEC3_TX_IP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C7:112"},
    {hpc_qoriq_p2020_ETSEC3_TX_TCP_UDP_PACKET_WITH_CHECKSUM_VT_DEF,
	{1000},	"C8:112"},
    {hpc_qoriq_p2020_ETSEC3_TCP_UDP_PACKETS_CHECKED_FOR_CS_VT_DEF,
	{1000},	"C9:94"},
    {hpc_qoriq_p2020_ETSEC3_IP_OR_TCP_UDP_RX_CHECKSUM_ERROR_VT_DEF,
	{1000},	"C1:106"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_REJECTED_FRAMES_BY_FILER_VT_DEF,
	{1000},	"C2:114"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_REJECTED_FRAMES_DUE_TO_FILER_ERROR_VT_DEF,
	{1000},	"C3:116"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_CYCLES_RX_FIFO_GT_1_4_FULL_VT_DEF,
	{1000},	"C9:97"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_CYCLES_RX_FIFO_GT_1_2_FULL_VT_DEF,
	{1000},	"C1:109"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_CYCLES_RX_FIFO_GT_3_4_FULL_VT_DEF,
	{1000},	"C2:116"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_CYCLES_RX_FIFO_EQ_FULL_VT_DEF,
	{1000},	"C3:118"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_ACCEPTED_FRAMES_MATCH_VT_DEF,
	{1000},	"C9:116"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_ACCEPTED_FRAMS_TO_STATION_ADDRESS_VT_DEF,
	{1000},	"C10:84"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_ACCEPTED_UNICASET_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C11:82"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_ACCEPTED_GROUP_FRAMES_VIA_HASH_VT_DEF,
	{1000},	"C6:98"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_ACCEPTED_FRAMS_VIA_EXACT_MATCH_VT_DEF,
	{1000},	"C7:102"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_REJECTED_FRAMES_AT_LAYER_2_VT_DEF,
	{1000},	"C9:117"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_RX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C8:97"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_TX_INTERRUPTS_SIGNALLED_VT_DEF,
	{1000},	"C9:118"},
    {hpc_qoriq_p2020_ETSEC3_RX_DATA_WRITE_LIFETIME_DURATION_THRESHOLD_VT_DEF,
	{1000},	"C10:85"},
    {hpc_qoriq_p2020_ETSEC3_NUMBER_OF_RX_PACKETS_RECEIVED_WHILE_RX_FIFO_IS_FULL_VT_DEF,
	{1000},	"C11:83"},

    /* PCI Express 1 Events */
    {hpc_qoriq_p2020_PCI1_INBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C8:119"},
    {hpc_qoriq_p2020_PCI1_INBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C9:101"},
    {hpc_qoriq_p2020_PCI1_INBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C5:124"},
    {hpc_qoriq_p2020_PCI1_OUTBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C6:126"},
    {hpc_qoriq_p2020_PCI1_OUTBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C7:125"},
    {hpc_qoriq_p2020_PCI1_OUTBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C8:124"},
    {hpc_qoriq_p2020_PCI1_INBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:54"},
    {hpc_qoriq_p2020_PCI1_OUTBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:55"},

    /* PCI Express 2 Events */
    {hpc_qoriq_p2020_PCI2_INBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C3:102"},
    {hpc_qoriq_p2020_PCI2_INBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C4:103"},
    {hpc_qoriq_p2020_PCI2_INBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C5:97"},
    {hpc_qoriq_p2020_PCI2_OUTBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C1:95"},
    {hpc_qoriq_p2020_PCI2_OUTBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C2:101"},
    {hpc_qoriq_p2020_PCI2_OUTBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C11:87"},
    {hpc_qoriq_p2020_PCI2_INBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:32"},
    {hpc_qoriq_p2020_PCI2_OUTBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:33"},

    /* PCI Express 3 Events */
    {hpc_qoriq_p2020_PCI3_INBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C9:124"},
    {hpc_qoriq_p2020_PCI3_INBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C10:90"},
    {hpc_qoriq_p2020_PCI3_INBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C11:89"},
    {hpc_qoriq_p2020_PCI3_OUTBOUND_PCI_EXPRESS_READ_VT_DEF,
	{1000},	"C6:102"},
    {hpc_qoriq_p2020_PCI3_OUTBOUND_PCI_EXPRESS_WRITE_VT_DEF,
	{1000},	"C7:98"},
    {hpc_qoriq_p2020_PCI3_OUTBOUND_PCI_EXPRESS_DATA_VT_DEF,
	{1000},	"C8:127"},
    {hpc_qoriq_p2020_PCI3_INBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:61"},
    {hpc_qoriq_p2020_PCI3_OUTBOUND_STATIC_QUEUE_0_START_DURATION_THRESHOLD_VT_DEF,
	{1000},	"Ref1:62"},

    /* Serial RapidIO 1 Events */
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_PACKET_ACCEPTED_VT_DEF,
	{1000},	"C1:124"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_PRIORITY_0_PACKET_ACCEPTED_VT_DEF,
	{1000},	"C2:126"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_NON_IDLES_RECEIVED_VT_DEF,
	{1000},	"C4:126"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_PACKET_RETRY_OCCURRED_VT_DEF,
	{1000},	"C5:83"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_BUFFER_IS_FULL_VT_DEF,
	{1000},	"C6:85"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_INBOUND_BUFFER_IS_FULL_TO_PRIORITY_0_VT_DEF,
	{1000},	"C7:123"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_NON_IDLES_TRANSMITTED_VT_DEF,
	{1000},	"Ref1:59"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_PACKET_SENT_TO_RAPIDIO_INTERFACE_VT_DEF,
	{1000},	"C2:127"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_PACKET_WAS_MISALIGNED_VT_DEF,
	{1000},	"C4:76"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_PACKET_WAS_RETRIED_VT_DEF,
	{1000},	"C5:84"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_PACKET_WAS_REORDERED_VT_DEF,
	{1000},	"C6:73"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_PACKET_SENT_TO_RIO_OF_PRIORITY_0_VT_DEF,
	{1000},	"C7:124"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_BUFFER_IS_FULL_VT_DEF,
	{1000},	"C8:123"},
    {hpc_qoriq_p2020_SERIALRAPIDIO1_OUTBOUND_BUFFER_IS_FULL_TO_PRIORITY_0_VT_DEF,
	{1000},	"C9:103"},

    /* Serial RapidIO 2 Events */
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_PACKET_ACCEPTED_VT_DEF,
	{1000},	"C3:77"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_PRIORITY_0_PACKET_ACCEPTED_VT_DEF,
	{1000},	"C10:64"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_NON_IDLES_RECEIVED_VT_DEF,
	{1000},	"C11:64"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_PACKET_RETRY_OCCURRED_VT_DEF,
	{1000},	"C8:70"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_BUFFER_IS_FULL_VT_DEF,
	{1000},	"C7:71"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_INBOUND_BUFFER_IS_FULL_TO_PRIORITY_0_VT_DEF,
	{1000},	"C9:65"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_NON_IDLES_TRANSMITTED_VT_DEF,
	{1000},	"Ref1:41"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_PACKET_SENT_TO_RAPIDIO_INTERFACE_VT_DEF,
	{1000},	"C1:72"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_PACKET_WAS_MISALIGNED_VT_DEF,
	{1000},	"C5:65"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_PACKET_WAS_RETRIED_VT_DEF,
	{1000},	"C11:126"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_PACKET_WAS_REORDERED_VT_DEF,
	{1000},	"C7:109"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_PACKET_SENT_TO_RIO_OF_PRIORITY_0_VT_DEF,
	{1000},	"C3:126"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_BUFFER_IS_FULL_VT_DEF,
	{1000},	"C5:82"},
    {hpc_qoriq_p2020_SERIALRAPIDIO2_OUTBOUND_BUFFER_IS_FULL_TO_PRIORITY_0_VT_DEF,
	{1000},	"C1:112"},

    /* RapidIO Message Unit Events */
    {hpc_qoriq_p2020_INBOUND_PACKET_RECEIVED_VT_DEF,
	{1000},	"Ref1:60"},
    {hpc_qoriq_p2020_INBOUND_PRIORITY_0_PACKET_RECEIVED_VT_DEF,
	{1000},	"C5:77"},
    {hpc_qoriq_p2020_INBOUND_BUFFER_IS_FULL_VT_DEF,
	{1000},	"C6:72"},
    {hpc_qoriq_p2020_INBOUND_BUFFER_IS_FULL_FOR_PRIORITY_0_VT_DEF,
	{1000},	"C7:72"},
    {hpc_qoriq_p2020_PACKET_SENT_TO_OCEAN_VT_DEF,
	{1000},	"C8:102"},
    {hpc_qoriq_p2020_PACKET_SENT_TO_OCEAN_OF_PRIORITY_0_VT_DEF,
	{1000},	"C11:94"},

    /* Local Bus Events */
    {hpc_qoriq_p2020_NUMBER_OF_CORRECTABLE_FCM_ECC_ERRORS_VT_DEF,
	{1000},	"C3:121"},
    {hpc_qoriq_p2020_NUMBER_OF_UNCORRECTABLE_FCM_ECC_ERRORS_VT_DEF,
	{1000},	"C6:119"},
    {hpc_qoriq_p2020_ATOMIC_RESERVATION_TIME_OUTS_FOR_ECM_PORT_VT_DEF,
	{1000},	"C6:118"},
    {hpc_qoriq_p2020_CYCLES_FOR_A_READ_TO_FCM_BUFFER_RAM_VT_DEF,
	{1000},	"C7:115"},
    {hpc_qoriq_p2020_CYCLES_FOR_A_WRITE_TO_FCM_BUFFER_RAM_VT_DEF,
	{1000},	"C8:115"},
    {hpc_qoriq_p2020_CYCLES_A_READ_IS_TAKING_IN_GPCM_VT_DEF,
	{1000},	"C1:117"},
    {hpc_qoriq_p2020_CYCLES_A_READ_IS_TAKING_IN_UPM_VT_DEF,
	{1000},	"C2:122"},
    {hpc_qoriq_p2020_CYCLES_A_WRITE_IS_TAKING_IN_GPCM_VT_DEF,
	{1000},	"C4:120"},
    {hpc_qoriq_p2020_CYCLES_A_WRITE_IS_TAKING_IN_UPM_VT_DEF,
	{1000},	"C5:114"},

    /* L2 Cache/SRAM Events */
    {hpc_qoriq_p2020_CORE_INSTRUCTION_ACCESSES_TO_L2_THAT_HIT_VT_DEF,
	{1000},	"C2:123"},
    {hpc_qoriq_p2020_CORE_INSTRUCTION_ACCESSES_TO_L2_THAT_MISS_VT_DEF,
	{1000},	"Ref1:23"},
    {hpc_qoriq_p2020_CORE_DATA_ACCESSES_TO_L2_THAT_HIT_VT_DEF,
	{1000},	"C4:121"},
    {hpc_qoriq_p2020_CORE_DATA_ACCESSES_TO_L2_THAT_MISS_VT_DEF,
	{1000},	"C5:115"},
    {hpc_qoriq_p2020_NON_CORE_BURST_WRITE_TO_L2_CACHE_EXTERNAL_WRITE_OR_SRAM_VT_DEF,
	{1000},	"C6:120"},
    {hpc_qoriq_p2020_NON_CORE_NON_BURST_WRITE_TO_L2_VT_DEF,
	{1000},	"C7:116"},
    {hpc_qoriq_p2020_NON_CORE_WRITE_MISSES_CACHE_EXTERNAL_WRITE_WINDOW_AND_SRAM_MEMORY_RANGE_VT_DEF,
	{1000},	"Ref1:24"},
    {hpc_qoriq_p2020_NON_CORE_READ_HIT_IN_L2_VT_DEF,
	{1000},	"C1:118"},
    {hpc_qoriq_p2020_NON_CORE_READ_MISS_IN_L2_VT_DEF,
	{1000},	"Ref1:25"},
    {hpc_qoriq_p2020_L2_ALLOCATES_FROM_ANY_SOURCE_VT_DEF,
	{1000},	"C2:124"},
    {hpc_qoriq_p2020_L2_RETRIES_DUE_TO_FULL_WRITE_QUEUE_VT_DEF,
	{1000},	"C3:122"},
    {hpc_qoriq_p2020_L2_RETRIES_DUE_TO_ADDRESS_COLLISION_VT_DEF,
	{1000},	"C4:122"},
    {hpc_qoriq_p2020_L2_FAILED_LOCK_ATTEMPTS_DUE_TO_FULL_SET_VT_DEF,
	{1000},	"C5:116"},
    {hpc_qoriq_p2020_L2_VICTIMIZATIONS_OF_VALID_LINES_VT_DEF,
	{1000},	"C6:121"},
    {hpc_qoriq_p2020_L2_INVALIDATIONS_OF_LINES_VT_DEF,
	{1000},	"C7:117"},
    {hpc_qoriq_p2020_L2_CLEARING_OF_LOCKS_VT_DEF,
	{1000},	"Ref1:22"},

    /* Debug Events */
    {hpc_qoriq_p2020_EXTERNAL_EVENT_VT_DEF,
	{1000},	"C3:125"},
    {hpc_qoriq_p2020_WATCHPOINT_MONITOR_HITS_VT_DEF,
	{1000},	"C2:125"},
    {hpc_qoriq_p2020_TRACE_BUFFER_HITS_VT_DEF,
	{1000},	"C1:122"},

    /* DUART Events */
    {hpc_qoriq_p2020_UART0_BAUD_RATE_VT_DEF,
	{1000},	"C1:127"},
    {hpc_qoriq_p2020_UART1_BAUD_RATE_VT_DEF,
	{1000},	"C5:127"}};

const unsigned int hpcHwDrvP2020NumEvents = CAFE_NELEMENTS(hpcDrvEvtDescFslP2020);

struct driverInstE500 hpcHwDrvP2020 =
    {
    "P2020 Device Events",
    0,
    NUM_COUNTERS,
    COUNTER_SIZE_MASK,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
    };
