/* Copyright (c) 2010 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

#include <stdlib.h>
#include <string.h>

#include <hpc/hpc_drv/hpcHwDrvApi.h>
#include <hpc/drv_evt_cfg/hpcDrvEvtCfg.h>
#include <hpc/hpc_drv/ppc/e500Drv.h>
#include <hpc/drv_evt_cfg/ppc/e500DrvEvtCfg.h>
#include <hpc/drv_evt_cfg/ppc/mpc8540EvtCfg.h>
#include <cafe/autogenerated/hpc_common.type.h>
#include <cafe/autogenerated/hpc_mpc8540.type.h>

#define NUM_COUNTERS	9
#define COUNTER_SIZE_MASK 0x1 /* PMC0 64bit, PMC1-PMC8 are 32bit */

struct e500EventDescription hpcDrvEvtDescMpc8540[] = {
    /* common named events */
    {hpc_level_2_instruction_cache_hit_VT_DEF,
	{5000}, "Ref1:22"},
    {hpc_level_2_instruction_cache_miss_VT_DEF,
	{5000}, "C2:59"},
    {hpc_level_2_data_cache_hit_VT_DEF,
	{5000}, "Ref1:23"},
    {hpc_level_2_data_cache_miss_VT_DEF,
	{5000}, "C4:57"},

    /* hw specific named events */
    /* General Events */
    {hpc_mpc8540_SYSTEM_CYCLES_VT_DEF,
	{100000}, "C0:0"},

    /*  DDR Memory Controller events */
    {hpc_mpc8540_CYCLES_A_READ_IS_RETURNING_DATA_FROM_DDR_SDRAM_VT_DEF,
	{1000}, "Ref1:10"},
    {hpc_mpc8540_CYCLES_A_READ_OR_WRITE_TRANSFERS_DATA_FROM_OR_TO_DDR_SDRAM_VT_DEF,
	{1000}, "Ref1:11"},
    {hpc_mpc8540_PIPELINED_READ_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C1:57"},
    {hpc_mpc8540_PIPELINED_READ_OR_WRITE_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C2:0"},
    {hpc_mpc8540_NON_PIPELINED_READ_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C3:60"},
    {hpc_mpc8540_NON_PIPELINED_READ_OR_WRITE_MISSES_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C4:0"},
    {hpc_mpc8540_PIPELINED_READ_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C5:56"},
    {hpc_mpc8540_PIPELINED_READ_OR_WRITE_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C6:0"},
    {hpc_mpc8540_NON_PIPELINED_READ_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C7:57"},
    {hpc_mpc8540_NON_PIPELINED_READ_OR_WRITE_HITS_IN_THE_ROW_OPEN_TABLE_VT_DEF,
	{1000}, "C8:0"},
    {hpc_mpc8540_FORCED_PAGE_CLOSINGS_NOT_CAUSED_BY_A_REFRESH_VT_DEF,
	{1000}, "C1:0"},
    {hpc_mpc8540_ROW_OPEN_TABLE_MISSES_VT_DEF,
	{1000}, "C2:1"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_VT_DEF,
	{1000}, "C3:0"},
    {hpc_mpc8540_FORCE_PAGE_CLOSINGS_VT_DEF,
	{1000}, "C4:1"},
    {hpc_mpc8540_READ_MODIFY_WRITE_TRANSACTIONS_DUE_TO_ECC_VT_DEF,
	{1000}, "C5:0"},
    {hpc_mpc8540_FORCED_PAGE_CLOSINGS_DUE_TO_COLLISION_WITH_BANK_AND_SUB_BANK_VT_DEF,
	{1000}, "REF1:12"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_CORE_VT_DEF,
	{1000}, "Ref1:13"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_TSEC_1_VT_DEF,
	{1000}, "C3:1"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_TSEC_2_VT_DEF,
	{1000}, "C4:2"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_RAPIDIO_VT_DEF,
	{1000}, "C3:2"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_PCI_VT_DEF,
	{1000}, "C4:3"},
    {hpc_mpc8540_READS_OR_WRITES_FROM_DMA_VT_DEF,
	{1000}, "C5:2"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_CORE_VT_DEF,
	{1000}, "Ref1:14"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_TSEC_1_VT_DEF,
	{1000}, "C6:1"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_TSEC_2_VT_DEF,
	{1000}, "C7:0"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_RAPIDIO_VT_DEF,
	{1000}, "C6:2"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_PCI_VT_DEF,
	{1000}, "C7:1"},
    {hpc_mpc8540_ROW_OPEN_TABLE_HITS_FOR_READS_OR_WRITES_FROM_DMA_VT_DEF,
	{1000}, "C8:2"},

    /* Memory Target Queue Events */
    {hpc_mpc8540_MEM_TQ_READ_WRITE_ADDRESS_COLLISION_VT_DEF,
	{1000}, "C5:5"},

    /* RapidIO Controller Events */
    {hpc_mpc8540_MISALIGNED_TRANSACTIONS_ON_RAPIDIO_VT_DEF,
	{1000}, "C4:11"},
    {hpc_mpc8540_RETRIED_PACKETS_ON_RAPIDIO_TRANSMIT_DUE_TO_RESOURCE_LIMITATIONS_VT_DEF,
	{1000}, "C2:62"},
    {hpc_mpc8540_FLUSHED_PACKETS_DUE_TO_PRIOR_RETRIES_OR_ERROR_RECOVERY_ON_RAPIDIO_TRANSMIT_VT_DEF,
	{1000}, "C3:10"},
    {hpc_mpc8540_RETRIED_OR_NOT_ACCEPTED_PACKETS_ON_RAPIDIO_RX_VT_DEF,
	{1000}, "C5:7"},
    {hpc_mpc8540_MISALIGNED_ENGINE_PRIORITY_2_OCCUPIED_VT_DEF,
	{1000}, "C5:12"},
    {hpc_mpc8540_MISALIGNED_ENGINE_PRIORITY_1_OCCUPIED_VT_DEF,
	{1000}, "C6:12"},
    {hpc_mpc8540_MISALIGNED_ENGINE_PRIORITY_0_OCCUPIED_VT_DEF,
	{1000}, "C7:10"},
    {hpc_mpc8540_ACK_HISTORY_QUEUE_FULL_VT_DEF,
	{1000}, "C4:61"},
    {hpc_mpc8540_OUTBOUND_RAPIDIO_STOPPED_FOR_TRAINING_EVENT_VT_DEF,
	{1000}, "C6:13"},
    {hpc_mpc8540_RAPIDIO_OUTBOUND_RETRY_STOPPED_EVENT_VT_DEF,
	{1000}, "C7:11"},
    {hpc_mpc8540_OUTBOUND_RAPIDIO_ERROR_STOPPED_EVENT_VT_DEF,
	{1000}, "C8:11"},
    {hpc_mpc8540_INBOUND_MESSAGE_PACKET_PROTOCOL_LEVEL_RETRY_VT_DEF,
	{1000}, "C4:18"},
    {hpc_mpc8540_INBOUND_DOORBELL_PACKET_PROTOCOL_LEVEL_RETRY_VT_DEF,
	{1000}, "C6:14"},
    {hpc_mpc8540_RAPIDIO_OUTBOUND_ACK_TIMEOUT_OUT_OF_ORDER_EVENT_VT_DEF,
	{1000}, "C8:12"},

    /* DMA Controller Events */
    {hpc_mpc8540_CHANNEL_0_READ_REQUEST_VT_DEF,
	{1000}, "C1:2"},
    {hpc_mpc8540_CHANNEL_1_READ_REQUEST_VT_DEF,
	{1000}, "C2:5"},
    {hpc_mpc8540_CHANNEL_2_READ_REQUEST_VT_DEF,
	{1000}, "C3:4"},
    {hpc_mpc8540_CHANNEL_3_READ_REQUEST_VT_DEF,
	{1000}, "C4:6"},
    {hpc_mpc8540_CHANNEL_0_WRITE_REQUEST_VT_DEF,
	{1000}, "C1:3"},
    {hpc_mpc8540_CHANNEL_1_WRITE_REQUEST_VT_DEF,
	{1000}, "C2:6"},
    {hpc_mpc8540_CHANNEL_2_WRITE_REQUEST_VT_DEF,
	{1000}, "C3:5"},
    {hpc_mpc8540_CHANNEL_3_WRITE_REQUEST_VT_DEF,
	{1000}, "C4:7"},
    {hpc_mpc8540_CHANNEL_0_DESCRIPTOR_REQUEST_VT_DEF,
	{1000}, "C5:41"},
    {hpc_mpc8540_CHANNEL_1_DESCRIPTOR_REQUEST_VT_DEF,
	{1000}, "C6:44"},
    {hpc_mpc8540_CHANNEL_2_DESCRIPTOR_REQUEST_VT_DEF,
	{1000}, "C7:41"},
    {hpc_mpc8540_CHANNEL_3_DESCRIPTOR_REQUEST_VT_DEF,
	{1000}, "C8:41"},
    {hpc_mpc8540_CHANNEL_0_READ_DW_OR_LESS_VT_DEF,
	{1000}, "C1:4"},
    {hpc_mpc8540_CHANNEL_0_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000}, "C5:53"},
    {hpc_mpc8540_CHANNEL_1_READ_DW_OR_LESS_VT_DEF,
	{1000}, "C2:7"},
    {hpc_mpc8540_CHANNEL_1_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000}, "C6:58"},
    {hpc_mpc8540_CHANNEL_2_READ_DW_OR_LESS_VT_DEF,
	{1000}, "C3:6"},
    {hpc_mpc8540_CHANNEL_2_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000}, "C7:54"},
    {hpc_mpc8540_CHANNEL_3_READ_DW_OR_LESS_VT_DEF,
	{1000}, "C4:8"},
    {hpc_mpc8540_CHANNEL_3_READ_DW_OR_LESS_EVENT2_VT_DEF,
	{1000}, "C8:52"},
    {hpc_mpc8540_CHANNEL_0_WRITE_DW_OR_LESS_VT_DEF,
	{1000}, "C1:5"},
    {hpc_mpc8540_CHANNEL_1_WRITE_DW_OR_LESS_VT_DEF,
	{1000}, "C2:8"},
    {hpc_mpc8540_CHANNEL_2_WRITE_DW_OR_LESS_VT_DEF,
	{1000}, "C3:7"},
    {hpc_mpc8540_CHANNEL_3_WRITE_DW_OR_LESS_VT_DEF,
	{1000}, "C4:9"},

    /* e500 Coherency Module (ECM) Events */
    {hpc_mpc8540_ECM_REQUEST_WAIT_CORE_VT_DEF,
	{1000}, "C8:13"},
    {hpc_mpc8540_ECM_REQUEST_WAIT_TSEC1_VT_DEF,
	{1000}, "C5:16"},
    {hpc_mpc8540_ECM_REQUEST_WAIT_TSEC2_VT_DEF,
	{1000}, "C6:16"},
    {hpc_mpc8540_ECM_REQUEST_WAIT_PCI_RAPIDIO_DMA_VT_DEF,
	{1000}, "C4:20"},
    {hpc_mpc8540_ECM_DISPATCH_VT_DEF,
	{1000}, "Ref1:15"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_CORE_VT_DEF,
	{1000}, "C1:16"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_TSEC1_VT_DEF,
	{1000}, "C3:19"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_TSEC2_VT_DEF,
	{1000}, "C4:21"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_RAPIDIO_VT_DEF,
	{1000}, "C5:17"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_PCI_VT_DEF,
	{1000}, "C6:17"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_DMA_VT_DEF,
	{1000}, "C7:14"},
    {hpc_mpc8540_ECM_DISPATCH_FROM_OTHER_VT_DEF,
	{1000}, "C8:14"},
    {hpc_mpc8540_ECM_DISPATCH_TO_DDR_VT_DEF,
	{1000}, "C4:22"},
    {hpc_mpc8540_ECM_DISPATCH_TO_L2_SRAM_VT_DEF,
	{1000}, "C5:18"},
    {hpc_mpc8540_ECM_DISPATCH_TO_LBC_VT_DEF,
	{1000}, "C6:18"},
    {hpc_mpc8540_ECM_DISPATCH_TO_RAPIDIO_VT_DEF,
	{1000}, "C7:15"},
    {hpc_mpc8540_ECM_DISPATCH_TO_PCI_VT_DEF,
	{1000}, "C8:15"},
    {hpc_mpc8540_ECM_DISPATCH_SNOOPABLE_VT_DEF,
	{1000}, "C3:20"},
    {hpc_mpc8540_ECM_DISPATCH_WRITE_VT_DEF,
	{1000}, "C1:17"},
    {hpc_mpc8540_ECM_DISPATCH_WRITE_ALLOCATE_VT_DEF,
	{1000}, "C2:21"},
    {hpc_mpc8540_ECM_DISPATCH_WRITE_ALLOCATE_LOCK_VT_DEF,
	{1000}, "C3:21"},
    {hpc_mpc8540_ECM_DISPATCH_READ_VT_DEF,
	{1000}, "C4:23"},
    {hpc_mpc8540_ECM_DISPATCH_READ_UNLOCK_VT_DEF,
	{1000}, "C5:19"},
    {hpc_mpc8540_ECM_DISPATCH_READ_CLEAR_ATOMIC_VT_DEF,
	{1000}, "C6:19"},
    {hpc_mpc8540_ECM_DISPATCH_READ_SET_ATOMIC_VT_DEF,
	{1000}, "C7:16"},
    {hpc_mpc8540_ECM_DISPATCH_READ_DECREMENT_ATOMIC_VT_DEF,
	{1000}, "C8:16"},
    {hpc_mpc8540_ECM_DISPATCH_READ_INCREMENT_ATOMIC_VT_DEF,
	{1000}, "C7:17"},
    {hpc_mpc8540_ECM_DATA_BUS_GRANT_DDR_VT_DEF,
	{1000}, "C1:18"},
    {hpc_mpc8540_ECM_DATA_BUS_GRANT_LBC_VT_DEF,
	{1000}, "C2:22"},
    {hpc_mpc8540_ECM_DATA_BUS_GRANT_PIC_VT_DEF,
	{1000}, "C1:19"},
    {hpc_mpc8540_ECM_DATA_BUS_GRANT_TSEC1_VT_DEF,
	{1000}, "C3:23"},
    {hpc_mpc8540_ECM_DATA_BUS_GRANT_TSEC2_VT_DEF,
	{1000}, "C4:25"},
    {hpc_mpc8540_ECM_DATA_BUS_WAIT_DDR_VT_DEF,
	{1000}, "C5:20"},
    {hpc_mpc8540_ECM_DATA_BUS_WAIT_LBC_VT_DEF,
	{1000}, "C6:20"},
    {hpc_mpc8540_ECM_DATA_BUS_WAIT_PIC_VT_DEF,
	{1000}, "C5:21"},
    {hpc_mpc8540_ECM_DATA_BUS_WAIT_TSEC1_VT_DEF,
	{1000}, "C7:19"},
    {hpc_mpc8540_ECM_DATA_BUS_WAIT_TSEC2_VT_DEF,
	{1000}, "C8:18"},
    {hpc_mpc8540_ECM_GLOBAL_DATA_BUS_BEAT_VT_DEF,
	{1000}, "Ref1:16"},
    {hpc_mpc8540_ECM_E500_DIRECT_READ_BUS_BEAT_VT_DEF,
	{1000}, "Ref1:17"},
    {hpc_mpc8540_ECM_E500_DIRECT_READ_BUS_BEAT_FORWARDED_VT_DEF,
	{1000}, "C2:24"},
    {hpc_mpc8540_ECM_CANCEL_VT_DEF,
	{1000}, "Ref1:18"},

    /* Interrupt Controller (PIC) Events */
    {hpc_mpc8540_PIC_TOTAL_INTERRUPT_COUNT_VT_DEF,
	{1000}, "Ref1:26"},
    {hpc_mpc8540_PIC_INTERRUPT_WAIT_CYCLES_VT_DEF,
	{1000}, "C8:62"},
    {hpc_mpc8540_PIC_INTERRUPT_SERVICE_CYCLES_VT_DEF,
	{1000}, "C2:19"},

    /* PCI/PCI-X Common Events */
    {hpc_mpc8540_PCI_PCI_X_CLOCK_CYCLES_VT_DEF,
	{1000}, "Ref1:28"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_MEMORY_READS_VT_DEF,
	{1000}, "C1:62"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_MEMORY_WRITES_VT_DEF,
	{1000}, "C2:37"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_CONFIG_READS_VT_DEF,
	{1000}, "C3:63"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_CONFIG_WRITES_VT_DEF,
	{1000}, "C4:37"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_MEMORY_READS_VT_DEF,
	{1000}, "C5:30"},
    {hpc_mpc8540_PCI_OUTBOUND_MEMORY_WRITES_PCI_X_OUTBOUND_MEMORY_WRITES_ATTEMPTED_VT_DEF,
	{1000}, "C6:32"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_I_O_READS_VT_DEF,
	{1000}, "C3:37"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_I_O_WRITES_VT_DEF,
	{1000}, "C4:38"},
    {hpc_mpc8540_PCI_OUTBOUND_CONFIG_READS_PCI_X_OUTBOUND_CONFIG_READS_ATTEMPTED_VT_DEF,
	{1000}, "C7:26"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_CONFIG_WRITES_VT_DEF,
	{1000}, "C8:26"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_TOTAL_READ_DATA_BEATS_VT_DEF,
	{1000}, "C5:32"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_TOTAL_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C6:34"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_TOTAL_READ_DATA_BEATS_VT_DEF,
	{1000}, "C7:28"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_TOTAL_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C8:28"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_32_BIT_READ_DATA_BEATS_VT_DEF,
	{1000}, "C1:30"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_32_BIT_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C2:38"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_32_BIT_READ_DATA_BEATS_VT_DEF,
	{1000}, "C3:38"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_32_BIT_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C4:39"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_64_BIT_READ_DATA_BEATS_VT_DEF,
	{1000}, "C5:31"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_64_BIT_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C6:33"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_64_BIT_READ_DATA_BEATS_VT_DEF,
	{1000}, "C7:27"},
    {hpc_mpc8540_PCI_PCI_X_OUTBOUND_64_BIT_WRITE_DATA_BEATS_VT_DEF,
	{1000}, "C8:27"},
    {hpc_mpc8540_PCI_PCI_X_TOTAL_TRANSACTIONS_VT_DEF,
	{1000}, "C7:29"},
    {hpc_mpc8540_PCI_PCI_X_64_BIT_TRANSACTIONS_VT_DEF,
	{1000}, "C8:29"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_PURGEABLE_READS_VT_DEF,
	{1000}, "C2:2"},
    {hpc_mpc8540_PCI_PCI_X_INBOUND_SPECULATIVE_READS_PURGEABLE_READS_DISCARDED_VT_DEF,
	{1000}, "C8:63"},
    {hpc_mpc8540_PCI_PCI_X_IDLE_CYCLES_VT_DEF,
	{1000}, "C1:31"},
    {hpc_mpc8540_PCI_PCI_X_DUAL_ADDRESS_CYCLES_VT_DEF,
	{1000}, "C2:40"},
    {hpc_mpc8540_PCI_PCI_X_INTERNAL_CYCLES_VT_DEF,
	{1000}, "C3:39"},
    {hpc_mpc8540_PCI_INBOUND_MEMORY_READ_PCI_X_INBOUND_MEMORY_32_BIT_READ_VT_DEF,
	{1000}, "C1:34"},
    {hpc_mpc8540_PCI_INBOUND_MEMORY_READLINE_PCI_X_INBOUND_MEMORY_ALIAS_READ_VT_DEF,
	{1000}, "C2:44"},
    {hpc_mpc8540_PCI_INBOUND_MEMORY_READ_MULTIPLE_PCI_X_INBOUND_MEMORY_BLOCK_READ_VT_DEF,
	{1000}, "C3:42"},
    {hpc_mpc8540_PCI_OUTBOUND_MEMORY_READS_PCI_X_OUTBOUND_MEMORY_DWORD_READS_ATTEMPTED_VT_DEF,
	{1000}, "C4:43"},
    {hpc_mpc8540_PCI_OUTBOUND_MEMORY_READ_LINES_PCI_X_OUTBOUND_MEMORY_BURST_READ_ATTEMPTED_VT_DEF,
	{1000}, "C5:36"},
    {hpc_mpc8540_PCI_WAIT_PCI_X_INITIAL_WAIT_VT_DEF,
	{1000}, "C1:35"},

    /* PCI Specific Events */
    {hpc_mpc8540_PCI_CYCLES_PCI_IRDY_IS_ASSERTED_VT_DEF,
	{1000}, "C6:36"},
    {hpc_mpc8540_PCI_CYCLES_PCI_TRDY_IS_ASSERTED_VT_DEF,
	{1000}, "C7:31"},
    {hpc_mpc8540_PCI_CYCLES_PCI_FRAME_IS_ASSERTED_VT_DEF,
	{1000}, "C8:31"},
    {hpc_mpc8540_PCI_X_1_SPLIT_TRANSACTION_VT_DEF,
	{1000}, "C2:41"},
    {hpc_mpc8540_PCI_X_2_SPLIT_TRANSACTIONS_VT_DEF,
	{1000}, "C3:40"},
    {hpc_mpc8540_PCI_X_3_SPLIT_TRANSACTIONS_VT_DEF,
	{1000}, "C4:41"},
    {hpc_mpc8540_PCI_X_4_SPLIT_TRANSACTIONS_VT_DEF,
	{1000}, "C5:34"},
    {hpc_mpc8540_PCI_X_SPLIT_RESPONSES_VT_DEF,
	{1000}, "C6:37"},
    {hpc_mpc8540_PCI_X_ADB_DISCONNECTS_VT_DEF,
	{1000}, "C7:32"},
    {hpc_mpc8540_PCI_PCI_X_SNOOPABLE_VT_DEF,
	{1000}, "C1:32"},
    {hpc_mpc8540_PCI_PCI_X_WRITE_STASH_VT_DEF,
	{1000}, "C2:42"},
    {hpc_mpc8540_PCI_PCI_X_WRITE_STASH_WITH_LOCK_VT_DEF,
	{1000}, "C3:41"},
    {hpc_mpc8540_PCI_PCI_X_READ_UNLOCK_VT_DEF,
	{1000}, "C4:42"},
    {hpc_mpc8540_PCI_PCI_X_BYTE_ENABLE_TRANSACTIONS_VT_DEF,
	{1000}, "C1:33"},
    {hpc_mpc8540_PCI_PCI_X_NON_BYTE_ENABLE_TRANSACTIONS_VT_DEF,
	{1000}, "C2:43"},

    /* Three-Speed Ethernet Controller (TSEC) Events */

    /* TSEC1 Address Data Filtering (ADF) Events */
    {hpc_mpc8540_TSEC1_ACCEPTED_FRAMES_VT_DEF,
	{1000}, "Ref1:36"},
    {hpc_mpc8540_TSEC1_INDIVIDUAL_HASH_TABLE_ACCEPTED_FRAME_VT_DEF,
	{1000}, "C7:35"},
    {hpc_mpc8540_TSEC1_GROUP_HASH_TABLE_ACCEPTED_FRAME_VT_DEF,
	{1000}, "C8:35"},
    {hpc_mpc8540_TSEC1_REJECTED_FRAMES_VT_DEF,
	{1000}, "Ref1:39"},
    {hpc_mpc8540_TSEC1_DROPPED_FRAMES_VT_DEF,
	{1000}, "Ref1:38"},
    {hpc_mpc8540_TSEC1_DROPPED_FRAMES_DUE_TO_DATA_OVERFLOW_VT_DEF,
	{1000}, "C1:41"},
    {hpc_mpc8540_TSEC1_DROPPED_FRAMES_DUE_TO_STATUS_OVERFLOW_VT_DEF,
	{1000}, "C2:50"},

    /* TSEC1 FIFO Events */
    {hpc_mpc8540_TSEC1_RECEIVE_FIFO_DATA_VALID_VT_DEF,
	{1000}, "C1:45"},
    {hpc_mpc8540_TSEC1_TRANSMIT_FRAMES_WITHOUT_THRESHOLD_VT_DEF,
	{1000}, "C7:44"},
    {hpc_mpc8540_TSEC1_RECEIVE_FIFO_ABOVE_1_4_VT_DEF,
	{1000}, "Ref1:47"},
    {hpc_mpc8540_TSEC1_RECEIVE_FIFO_ABOVE_1_2_VT_DEF,
	{1000}, "Ref1:48"},
    {hpc_mpc8540_TSEC1_RECEIVE_FIFO_ABOVE_3_4_VT_DEF,
	{1000}, "Ref1:49"},

    /* TSEC1 DMA Events */
    {hpc_mpc8540_TSEC1_DMA_READS_VT_DEF,
	{1000}, "C1:47"},
    {hpc_mpc8540_TSEC1_BD_READS_VT_DEF,
	{1000}, "C2:54"},
    {hpc_mpc8540_TSEC1_RXBD_READS_VT_DEF,
	{1000}, "C3:51"},
    {hpc_mpc8540_TSEC1_DMA_WRITES_VT_DEF,
	{1000}, "C4:52"},
    {hpc_mpc8540_TSEC1_BD_WRITES_VT_DEF,
	{1000}, "C5:46"},
    {hpc_mpc8540_TSEC1_RXBD_WRITES_VT_DEF,
	{1000}, "C6:49"},
    {hpc_mpc8540_TSEC1_RXBD_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:41"},
    {hpc_mpc8540_TSEC1_TXBD_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:42"},
    {hpc_mpc8540_TSEC1_RXBD_WRITE_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:43"},
    {hpc_mpc8540_TSEC1_TXBD_WRITE_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:44"},
    {hpc_mpc8540_TSEC1_TX_DATA_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:45"},
    {hpc_mpc8540_TSEC1_DATA_BEATS_VT_DEF,
	{1000}, "C7:48"},
    {hpc_mpc8540_TSEC1_READ_DATA_BEATS_VT_DEF,
	{1000}, "C8:46"},
    {hpc_mpc8540_TSEC1_RX_FRAME_INTERRUPTS_VT_DEF,
	{1000}, "C1:49"},
    {hpc_mpc8540_TSEC1_TX_FRAME_INTERRUPTS_VT_DEF,
	{1000}, "C3:53"},
    {hpc_mpc8540_TSEC1_RX_FRAME_PROCESSING_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:46"},

    /* TSEC2 Address Data Filtering (ADF) Events */
    {hpc_mpc8540_TSEC2_ACCEPTED_FRAMES_VT_DEF,
	{1000}, "Ref1:50"},
    {hpc_mpc8540_TSEC2_INDIVIDUAL_HASH_TABLE_ACCEPTED_FRAME_VT_DEF,
	{1000}, "C7:36"},
    {hpc_mpc8540_TSEC2_GROUP_HASH_TABLE_ACCEPTED_FRAME_VT_DEF,
	{1000}, "C8:36"},
    {hpc_mpc8540_TSEC2_REJECTED_FRAMES_VT_DEF,
	{1000}, "Ref1:53"},
    {hpc_mpc8540_TSEC2_DROPPED_FRAMES_VT_DEF,
	{1000}, "Ref1:52"},
    {hpc_mpc8540_TSEC2_DROPPED_FRAMES_DUE_TO_DATA_OVERFLOW_VT_DEF,
	{1000}, "C1:42"},
    {hpc_mpc8540_TSEC2_DROPPED_FRAMES_DUE_TO_STATUS_OVERFLOW_VT_DEF,
	{1000}, "C2:51"},

    /* TSEC2 FIFO Events */
    {hpc_mpc8540_TSEC2_RECEIVE_FIFO_DATA_VALID_VT_DEF,
	{1000}, "C1:46"},
    {hpc_mpc8540_TSEC2_TRANSMIT_FRAMES_WITHOUT_THRESHOLD_VT_DEF,
	{1000}, "C7:45"},
    {hpc_mpc8540_TSEC2_RECEIVE_FIFO_ABOVE_1_4_VT_DEF,
	{1000}, "Ref1:61"},
    {hpc_mpc8540_TSEC2_RECEIVE_FIFO_ABOVE_1_2_VT_DEF,
	{1000}, "Ref1:62"},
    {hpc_mpc8540_TSEC2_RECEIVE_FIFO_ABOVE_3_4_VT_DEF,
	{1000}, "Ref1:63"},

    /* TSEC1 DMA Events */
    {hpc_mpc8540_TSEC2_DMA_READS_VT_DEF,
	{1000}, "C1:48"},
    {hpc_mpc8540_TSEC2_BD_READS_VT_DEF,
	{1000}, "C2:55"},
    {hpc_mpc8540_TSEC2_RXBD_READS_VT_DEF,
	{1000}, "C3:52"},
    {hpc_mpc8540_TSEC2_DMA_WRITES_VT_DEF,
	{1000}, "C4:53"},
    {hpc_mpc8540_TSEC2_BD_WRITES_VT_DEF,
	{1000}, "C5:47"},
    {hpc_mpc8540_TSEC2_RXBD_WRITES_VT_DEF,
	{1000}, "C6:50"},
    {hpc_mpc8540_TSEC2_RXBD_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:55"},
    {hpc_mpc8540_TSEC2_TXBD_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:56"},
    {hpc_mpc8540_TSEC2_RXBD_WRITE_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:57"},
    {hpc_mpc8540_TSEC2_TXBD_WRITE_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:58"},
    {hpc_mpc8540_TSEC2_TX_DATA_READ_LATENCY_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:59"},
    {hpc_mpc8540_TSEC2_DATA_BEATS_VT_DEF,
	{1000}, "C7:49"},
    {hpc_mpc8540_TSEC2_READ_DATA_BEATS_VT_DEF,
	{1000}, "C8:47"},
    {hpc_mpc8540_TSEC2_RX_FRAME_INTERRUPTS_VT_DEF,
	{1000}, "C1:50"},
    {hpc_mpc8540_TSEC2_TX_FRAME_INTERRUPTS_VT_DEF,
	{1000}, "C3:54"},
    {hpc_mpc8540_TSEC2_RX_FRAME_PROCESSING_DURATION_THRESHOLD_VT_DEF,
	{1000}, "Ref1:60"},

    /* Local Bus Events */
    {hpc_mpc8540_BANK_1_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C1:51"},
    {hpc_mpc8540_BANK_2_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C2:56"},
    {hpc_mpc8540_BANK_3_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C3:55"},
    {hpc_mpc8540_BANK_4_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C4:54"},
    {hpc_mpc8540_BANK_5_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C5:48"},
    {hpc_mpc8540_BANK_6_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C6:53"},
    {hpc_mpc8540_BANK_7_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C7:50"},
    {hpc_mpc8540_BANK_8_HITS_CHIP_SELECT_VT_DEF,
	{1000}, "C8:50"},
    {hpc_mpc8540_REQUESTS_GRANTED_TO_ECM_PORT_VT_DEF,
	{1000}, "C2:57"},
    {hpc_mpc8540_CYCLES_ATOMIC_RESERVATION_FOR_ECM_PORT_IS_ENABLED_VT_DEF,
	{1000}, "C4:55"},
    {hpc_mpc8540_ATOMIC_RESERVATION_TIME_OUTS_FOR_ECM_PORT_VT_DEF,
	{1000}, "C6:54"},
    {hpc_mpc8540_CYCLES_A_READ_IS_TAKING_IN_GPCM_VT_DEF,
	{1000}, "C1:53"},
    {hpc_mpc8540_CYCLES_A_READ_IS_TAKING_IN_UPM_VT_DEF,
	{1000}, "C2:58"},
    {hpc_mpc8540_CYCLES_A_READ_IS_TAKING_IN_SDRAM_VT_DEF,
	{1000}, "C3:57"},
    {hpc_mpc8540_CYCLES_A_WRITE_IS_TAKING_IN_GPCM_VT_DEF,
	{1000}, "C4:56"},
    {hpc_mpc8540_CYCLES_A_WRITE_IS_TAKING_IN_UPM_VT_DEF,
	{1000}, "C5:50"},
    {hpc_mpc8540_CYCLES_A_WRITE_IS_TAKING_IN_SDRAM_VT_DEF,
	{1000}, "C6:55"},
    {hpc_mpc8540_SDRAM_BANK_MISSES_VT_DEF,
	{1000}, "C7:51"},
    {hpc_mpc8540_SDRAM_PAGE_MISSES_VT_DEF,
	{1000}, "C8:51"},

    /* L2 Cache/SRAM Events */
    {hpc_mpc8540_CORE_INSTRUCTION_ACCESSES_TO_L2_THAT_HIT_VT_DEF,
	{1000}, "Ref1:22"},
    {hpc_mpc8540_CORE_INSTRUCTION_ACCESSES_TO_L2_THAT_MISS_VT_DEF,
	{1000}, "C2:59"},
    {hpc_mpc8540_CORE_DATA_ACCESSES_TO_L2_THAT_HIT_VT_DEF,
	{1000}, "Ref1:23"},
    {hpc_mpc8540_CORE_DATA_ACCESSES_TO_L2_THAT_MISS_VT_DEF,
	{1000}, "C4:57"},
    {hpc_mpc8540_NON_CORE_BURST_WRITE_TO_L2_CACHE_EXTERNAL_WRITE_OR_SRAM_VT_DEF,
	{1000}, "C5:51"},
    {hpc_mpc8540_NON_CORE_NON_BURST_WRITE_TO_L2_VT_DEF,
	{1000}, "C6:56"},
    {hpc_mpc8540_NON_CORE_WRITE_MISSES_CACHE_EXTERNAL_WRITE_WINDOW_AND_SRAM_MEMORY_RANGE_VT_DEF,
	{1000}, "C7:52"},
    {hpc_mpc8540_NON_CORE_READ_HIT_IN_L2_VT_DEF,
	{1000}, "Ref1:24"},
    {hpc_mpc8540_NON_CORE_READ_MISS_IN_L2_VT_DEF,
	{1000}, "C1:54"},
    {hpc_mpc8540_L2_ALLOCATES_FROM_ANY_SOURCE_VT_DEF,
	{1000}, "Ref1:25"},
    {hpc_mpc8540_L2_RETRIES_DUE_TO_FULL_WRITE_QUEUE_VT_DEF,
	{1000}, "C2:60"},
    {hpc_mpc8540_L2_RETRIES_DUE_TO_ADDRESS_COLLISION_VT_DEF,
	{1000}, "C3:58"},
    {hpc_mpc8540_L2_FAILED_LOCK_ATTEMPTS_DUE_TO_FULL_SET_VT_DEF,
	{1000}, "C4:58"},
    {hpc_mpc8540_L2_VICTIMIZATIONS_OF_VALID_LINES_VT_DEF,
	{1000}, "C5:52"},
    {hpc_mpc8540_L2_INVALIDATIONS_OF_LINES_VT_DEF,
	{1000}, "C6:57"},
    {hpc_mpc8540_L2_CLEARING_OF_LOCKS_VT_DEF,
	{1000}, "C7:53"},

    /* Debug Events */
    {hpc_mpc8540_EXTERNAL_EVENT_VT_DEF,
	{1000}, "C3:61"},
    {hpc_mpc8540_WATCHPOINT_MONITOR_HITS_VT_DEF,
	{1000}, "C2:61"},
    {hpc_mpc8540_TRACE_BUFFER_HITS_VT_DEF,
	{1000}, "C1:58"},

    /* DUART Events */
    {hpc_mpc8540_UART0_BAUD_RATE_VT_DEF,
	{1000}, "C1:63"},
    {hpc_mpc8540_UART1_BAUD_RATE_VT_DEF,
	{1000}, "C1:58"}};

const unsigned int hpcMpc8540NumEvents = CAFE_NELEMENTS(hpcDrvEvtDescMpc8540);

struct driverInstE500 hpcHwDrvMpc8540 =
    {
    "MPC8540 Device Events",
    0,
    NUM_COUNTERS,
    COUNTER_SIZE_MASK,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
    };
