/* Copyright (c) 2010, 2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
09sep14,wzc  support arm hpc events.(US17715)
03aug14,sdt  Fixed checked-return warnings (US45196)
13mar14,wzc  support arm hpc(US17715)
*/

/*
DESCRIPTION
*/
#include <stdio.h>
#include <stdlib.h>

#include <test/cafe_CUnitTest.h>
#include <hpc/hpc_ep.h>
#include <hpc/hpc_ep_test.h>

#include "hpc_test.h"

extern void hpcCfgInit(void);
extern void hpcCfgFinit(void);

void hpc_init_arm_cortex_a8_tests(void)
{
	hpc_test_hte = test_events_arm_cortex_a8;
}

void hpc_init_arm_cortex_a9_tests(void)
{
	hpc_test_hte = test_events_arm_cortex_a9;
}

void hpc_init_arm_cortex_a15_tests(void)
{
	hpc_test_hte = test_events_arm_cortex_a15;
}

void hpc_init_e500mc_tests(void)
{
	hpc_test_hte = test_events_e500mc;
}

void hpc_init_fsl_p2020_tests(void)
{
	hpc_test_hte = test_events_p2020;
}

void hpc_init_mpc_8540_tests(void)
{
	hpc_test_hte = test_events_e500;
}

void hpc_init_mpc_8548_tests(void)
{
	hpc_test_hte = test_events_mpc8548;
}

void hpc_init_core2_tests(void)
{
	hpc_test_hte = test_events_x86_core2;
}

void hpc_init_corei7_tests(void)
{
	hpc_test_hte = test_events_x86_corei7;
}

static int hpc_tst_init_vxw_hw_test(void)
{
	hpc_test_htf[0] = NULL;
	hpcCfgInit();
	return 0;
}

static int hpc_tst_finit_vxw_hw_test(void)
{
	hpc_test_htf[0] = NULL;
	hpcCfgFinit();
	return 0;
}

CUT_BEGIN_TEST_HARNESS(hpc_unit_test_hw)
	printf("TEST_VXW_HPC_HW_DRV\n");
	(void)hpc_tst_finit_vxw_hw_test();
	hpc_hw_drv_type = TEST_VXW_HPC_HW_DRV;
	hpc_hw_drv_vxw_test_init = hpc_tst_init_vxw_hw_test;
	hpc_hw_drv_vxw_test_finit = hpc_tst_finit_vxw_hw_test;

	CUT_RUN_SUITE_TESTS(hpc_suite1);
	CUT_RUN_SUITE_TESTS(hpc_suite2);
	if (hpc_test_hte == test_events_x86_core2)
		CUT_RUN_SUITE_TESTS(hpc_suite_core2);

	(void)hpc_tst_init_vxw_hw_test();
CUT_END_TEST_HARNESS
