/* Copyright (c) 2010-2014 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
09sep14,wzc  support arm hpc events.(US17715)
15may14,sdt  fixed resource leak
28mar14,sdt  fixed build issue in tcf-tools env.
13mar14,wzc  support arm hpc(US17715)
*/

/*
DESCRIPTION
*/
#ifndef INChpc_test_h
#define INChpc_test_h

#ifdef __cplusplus
extern "C" {
#endif

#include "../hpc_log.h"
#include "../tests_mock/hpcHwDriverTest.h"
#include "../tests_mock/e500DrvTest.h"
#include "../tests_mock/i86ArchPm1DrvTest.h"
#include "../tests_mock/i86ArchPm2DrvTest.h"
#include "../tests_mock/i86NehalemUncDrvTest.h"
#include "../tests_mock/armDrvTest.h"

#define TEST_VXW_HPC_HW_DRV		0
#define TEST_MPC8540_BOARD		1
#define TEST_I86_CORE2_BOARD		2
#define TEST_P2020_BOARD		3
#define TEST_I86_COREI7_BOARD		4
#define TEST_E500MC_TEST_BOARD		5
#define TEST_MPC8548_BOARD		6
#define TEST_ARM_CORTEX_A8_BOARD	7
#define TEST_ARM_CORTEX_A9_BOARD	8
#define TEST_ARM_CORTEX_A15_BOARD	9
extern int hpc_hw_drv_type;

extern int hpc_test_timeout;

/* hpc hw driver test functions */
extern struct hpcHwDrvTestFuncs *hpc_test_htf[];

extern int hpc_test_ctr_inc(int c, HPC_COUNTER value);
extern int hpc_test_print_counters(int cores);
extern void hpc_test_clear_counters(void);
extern int hpc_test_generate_isr(int p);
extern int hpc_test_check_counters(int ctr, HPC_COUNTER value, int cores);
extern int hpc_test_execute_bad_code(int ctr_mask);
extern int hpc_test_generate_event(int ctr_mask, unsigned int n,
	struct cafe_instrument *session, int *cores, const char *name1,
	const char *name2);
extern int hpc_test_driver_event_inc_n(struct cafe_namespace *, const char *,
	int, int *);
extern int hpc_test_driver_process_isr(void);

extern int (*hpc_hw_drv_vxw_test_init)(void);
extern int (*hpc_hw_drv_vxw_test_finit)(void);
extern void hpc_test_free(void *m);
extern int hpc_test_malloc_count;
extern int hpc_test_malloc_error;
extern int hpc_test_free_count;
extern struct hpc_virt_counter **hpc_test_vc;
extern const char ***hpc_test_hte;
extern const char ***hte_test2_inst2;
extern const char **test_events_e500[];
extern const char **test_events_x86_core2[];
extern const char **test_events_x86_corei7[];
extern const char **test_events_p2020[];
extern const char **test_events_e500mc[];
extern const char **test_events_mpc8548[];
extern const char **test_events_arm_cortex_a8[];
extern const char **test_events_arm_cortex_a9[];
extern const char **test_events_arm_cortex_a15[];

extern int hpc_test_num_vc;
extern void * hpc_test_malloc(size_t size);
extern int hpc_tst_init(void);
extern int hpc_tst_finit(void);
extern int hpc_test_init1(void);
extern int hpc_test_config_create1(void);
extern int hpc_test_config_create2(void);
extern int hpc_test_priv_init_vc_list1(void);
extern int hpc_test_priv_init_vc_list2(void);
extern int hpc_test_priv_vc_alloc1(void);
extern int hpc_test_priv_vc_alloc2(void);
extern int hpc_test_priv_vc_free1(void);
extern void hpc_test_priv_vc_teardown(void);
extern int hpc_test_priv_finit_vc_list1(void);
extern int hpc_test_priv_init_cfg_list1(void);
extern int hpc_test_priv_finit_cfg_list1(void);
extern int hpc_test_priv_alloc_cfg1(void);
extern int hpc_test_priv_alloc_cfg2(void);
extern int hpc_test_priv_free_cfg1(void);
extern int hpc_test_cafe1(void);
extern int hpc_test_cafe2(void);
extern int hpc_test_cafe3(void);
extern int hpc_test1_core2(void);
extern int utest_od_freq1(void);
extern int hpc_test_cafe5(void);
extern int hpc_test_orth_st(void);

#ifdef __VXWORKS__
#define hpc_test_timestamp_set(v)	do{}while(0)
#else
extern void hpc_test_timestamp_set(unsigned long long t);
#endif

#ifdef __cplusplus
}
#endif
#endif /* INChpc_test_h */

