/* logTimestamp.c - */

/* Copyright (c) 2009 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
01a,03Jun09,tcr  created
*/

/*
DESCRIPTION

*/


#include <stdio.h>
#include "logTimestamp.h"

static unsigned int previousT = 0;
static unsigned int rollovers = 0;
static unsigned int freq = 0;
static unsigned int period = 0;


/****************************************************************************
*
* logTimestampRead - read synthesized timestamp for top
*
* This function provides a synthesized timestamp for playing back log files on
* a host.
*
*/

void logTimestampRead(uint64_t *pHiResTime)
{
#ifdef PHOENIX_DEBUG
	printf("%lld\n", ((uint64_t) rollovers * period + previousT));
#endif
	*pHiResTime = ((uint64_t) rollovers * period + previousT);
}

/****************************************************************************
*
* logTimestampUpdate -
*
*/

void logTimestampUpdate(unsigned int t) {
	if (t < previousT)
		++rollovers;
	previousT = t;
}

/****************************************************************************
*
* logTimestampConfigSet -
*
* @param f   - frequency 
* @param per - period
*/

void logTimestampConfigSet(unsigned int f, unsigned int per)
{
	freq = f;
	period = per;
}

/****************************************************************************
*
* logTimestampFreqGet - get timestamp frequency
*
*
*/

void logTimestampFreqGet(uint64_t *pHiResFreq)
{
	*pHiResFreq = freq;
}
